#include <cstdio>

#include "bitboard.h"
#include "bit.h"
#include "shogi.h"

// ̎肪Ȃ1Ԃ
uint64 move_check_b(tree_t *ptree, unsigned int move)
{
	bitboard_t bb, occ;
	int from = (int)GetMoveFrom(move);
	int to = (int)GetMoveTo(move);
	int ipiece_move, idirec;

	OCC(occ);

	if (from >= nsquare) { // ł
		ipiece_move = DropPiece(from);
	}
	else { // Ֆʂ̋
		ipiece_move = (int)GetMovePiece(move);
		if (GetMovePromoted(move)) { // 
			ipiece_move += promote;
		}

		idirec = (int)adirec[SQ_WKING][from];
		if (idirec && idirec != (int)adirec[SQ_WKING][to] && pinned_white_king(ptree, from, idirec)) {
			return 1;
		}
	}

	switch (ipiece_move) {
	case pawn:
		return BOARD[to - 1] == king + enemy;
	case lance:
		AttackBLance(bb, to);
		return BBcontract(bb, BB_WKING);
	case knight:
		return BBcontract(b_knight_attacks[to], BB_WKING);
	case silver:
		return BBcontract(b_silver_attacks[to], BB_WKING);
	case bishop:
		bb = bishopAttacks(occ, to);
		return BBcontract(bb, BB_WKING);
	case rook:
		bb = rookAttacks(occ, to);
		return BBcontract(bb, BB_WKING);
	case king:
		return 0;
	case horse:
		bb = bishopAttacks(occ, to);
		BBor(bb, bb, king_attacks[to]);
		return BBcontract(bb, BB_WKING);
	case dragon:
		bb = rookAttacks(occ, to);
		BBor(bb, bb, king_attacks[to]);
		return BBcontract(bb, BB_WKING);
	case gold:
	case pro_pawn:
	case pro_lance:
	case pro_knight:
	case pro_silver:
		return BBcontract(b_gold_attacks[to], BB_WKING);
	default:
		break;
	}
	return 0;
}

// ɉ1
uint64  move_check_w(tree_t *ptree, unsigned int move)
{
	int from = (int)GetMoveFrom(move);
	int to = (int)GetMoveTo(move);
	int ipiece_move, idirec;
	bitboard_t bb, occ;

	OCC(occ);

	if (from >= nsquare) {
		ipiece_move = DropPiece(from); // ł
	}
	else {
		ipiece_move = (int)GetMovePiece(move); // ړ
		if (GetMovePromoted(move)) {
			ipiece_move += promote; // Ăꍇ͕ύX
		}
		idirec = (int)adirec[SQ_BKING][from]; // ړÖʒuƐʂ̈ʒu֌W
		if (idirec && idirec != (int)adirec[SQ_BKING][to] && pinned_black_king(ptree, from, idirec)) { // ̋Ƃɂđɉ肪邩(󂫉)
			return 1;
		}
	}

	switch (ipiece_move) { // ړ
	case pawn:
		return BOARD[to + 1] == king;
	case lance:
		AttackWLance(bb, to);
		return BBcontract(bb, BB_BKING);
	case knight:
		return BBcontract(w_knight_attacks[to], BB_BKING);
	case silver:
		return BBcontract(w_silver_attacks[to], BB_BKING);
	case bishop:
		bb = bishopAttacks(occ, to);
		return BBcontract(bb, BB_BKING);
	case rook:
		bb = rookAttacks(occ, to);
		return BBcontract(bb, BB_BKING);
	case king:
		return 0;
	case horse:
		bb = bishopAttacks(occ, to);
		BBor(bb, bb, king_attacks[to]);
		return BBcontract(bb, BB_BKING);
	case dragon:
		bb = rookAttacks(occ, to);
		BBor(bb, bb, king_attacks[to]);
		return BBcontract(bb, BB_BKING);
	case gold:
	case pro_pawn:
	case pro_lance:
	case pro_knight:
	case pro_silver:
		return BBcontract(w_gold_attacks[to], BB_BKING);
	default:
		break;
	}
	return 0;
}

// sq̈ʒuɂ̋̋ɎĂ܂ǂׂB
// Ă܂ꍇ́A̋̈ʒubbɊi[B
// ̋̋ƂꍇtrueAȂꍇfalseԂB
uint64 is_white_attacked(tree_t *ptree, int sq) {
	bitboard_t bb, bb1, bb_atk, occ, pawnAttack;

	OCC(occ);

	FU_ATTACKS(pawnAttack, BB_BPAWN, black);

	BBand(bb, pawnAttack, abb_mask[sq]);
	BBandor(bb, BB_BKNIGHT, w_knight_attacks[sq]);
	BBandor(bb, BB_BSILVER, w_silver_attacks[sq]);
	BBandor(bb, BB_BTGOLD, w_gold_attacks[sq]);
	BBandor(bb, BB_B_HDK, king_attacks[sq]);

	bb_atk = bishopAttacks(occ, sq);
	BBandor(bb, BB_B_BH, bb_atk);

	bb1 = BB_B_RD;
	BBandor(bb1, BB_BLANCE, minus_rays[sq]);
	BBandor(bb, bb1, AttackFile(sq));
	BBandor(bb, BB_B_RD, AttackRank(sq, occ));

	return BBToU(bb); // Ă΂Pȏ
}


// sqɂ̋̋ɎĂ܂ʒuȂtrueAłȂȂfalseԂB
uint64 is_black_attacked(tree_t *ptree, int sq) {
	bitboard_t bb, bb1, bb_atk, occ, pawnAttack;

	OCC(occ);
	FU_ATTACKS(pawnAttack, BB_WPAWN, white);
	BBand(bb, pawnAttack, abb_mask[sq]);
	BBandor(bb, BB_WKNIGHT, b_knight_attacks[sq]);
	BBandor(bb, BB_WSILVER, b_silver_attacks[sq]);
	BBandor(bb, BB_WTGOLD, b_gold_attacks[sq]);
	BBandor(bb, BB_W_HDK, king_attacks[sq]);

	bb_atk = bishopAttacks(occ, sq);
	BBandor(bb, BB_W_BH, bb_atk);

	bb1 = BB_W_RD;
	BBandor(bb1, BB_WLANCE, plus_rays[sq]);
	BBandor(bb, bb1, AttackFile(sq));
	BBandor(bb, BB_W_RD, AttackRank(sq, occ));

	return BBToU(bb); //Ă΂Pȏ
}

// s֌W
uint64 pinned_black_king(tree_t *ptree, int sq, int idirec) {
	bitboard_t bb_attacks, bb_attacker;
	bitboard_t occ;

	OCC(occ);
	switch (idirec) {
	case direc_rank: // Ԃɑ΂Ăpinx
		bb_attacks = AttackRank(sq, occ);
		if (BBcontract(bb_attacks, BB_BKING)) {
			return BBcontract(bb_attacks, BB_W_RD);
		}
		break;
	case direc_file: // cԁAԂɑ΂Ăpinx
		bb_attacks = AttackFile(sq);
		if (BBcontract(bb_attacks, BB_BKING)) {
			BBand(bb_attacker, BB_WLANCE, plus_rays[sq]);
			BBor(bb_attacker, bb_attacker, BB_W_RD);
			return BBcontract(bb_attacks, bb_attacker);
		}
		break;
	case direc_diag1: // E΂ߏpɑ΂Ăpinx
		bb_attacks = AttackDiag1(sq, occ);
		if (BBcontract(bb_attacks, BB_BKING)) {
			return BBcontract(bb_attacks, BB_W_BH);
		}
		break;
	case direc_diag2: // ΂ߏpɑ΂Ăpinx
		bb_attacks = AttackDiag2(sq, occ);
		if (BBcontract(bb_attacks, BB_BKING)) {
			return BBcontract(bb_attacks, BB_W_BH);
		}
		break;
	default:
		break;
	}
	return 0;
}

uint64  pinned_white_king(tree_t *ptree, int sq, int idirec) {
	bitboard_t bb_attacks, bb_attacker;
	bitboard_t occ;

	OCC(occ);

	switch (idirec) {
	case direc_rank:
		bb_attacks = AttackRank(sq, occ);
		if (BBcontract(bb_attacks, BB_WKING)) {
			return BBcontract(bb_attacks, BB_B_RD);
		}
		break;
	case direc_file:
		bb_attacks = AttackFile(sq);
		if (BBcontract(bb_attacks, BB_WKING)) {
			BBand(bb_attacker, BB_BLANCE, minus_rays[sq]); /* plus  minus */
			BBor(bb_attacker, bb_attacker, BB_B_RD);
			return BBcontract(bb_attacks, bb_attacker);
		}
		break;

	case direc_diag1:
		bb_attacks = AttackDiag1(sq, occ);
		if (BBcontract(bb_attacks, BB_WKING)) {
			return BBcontract(bb_attacks, BB_B_BH);
		}
		break;
	case direc_diag2:
		bb_attacks = AttackDiag2(sq, occ);
		if (BBcontract(bb_attacks, BB_WKING)) {
			return BBcontract(bb_attacks, BB_B_BH);
		}
		break;
	default:
		break;
	}
	return 0;
}

/* perpetual check detections are omitted. */
// is_mate_b_pawn_droṕAʂ̑łl݃`FbNi̕łƂɑłl݂ɂȂ邩j
// is_mate_w_pawn_droṕAʂ̑łl݃`FbN
// sq_drop = łƂƂꏊ
// łl߂ȂtrueԂB
// ɂ֑ɂȂł̉̃`FbN͂Ɋ܂܂ȂB

//łl : ɂẮA̕ijłđ̉l߂Ă͂ȂB
//              łꍇ͔ƂȂB
int CONV
is_mate_b_pawn_drop(tree_t * restrict ptree, int sq_drop)
{
	bitboard_t bb, bb_sum, bb_move;
	int iwk, ito, iret, ifrom, idirec;

	// bb_sum@F@łƂɁA̕G̋ɎĂ܂ʒuɂȂ
	//@@@@@@@ ̓G̋̈ʒubb_sumɊi[B
	// ̂ŕG̍Ɏ邱Ƃ͂ȂBĒׂKvȂ

	// sqɕłɌ̌jnɂĎĂ܂ʒuǂׂB
	BBand(bb_sum, BB_WKNIGHT, b_knight_attacks[sq_drop]);
	// ̋AAɂĎĂ܂ʒuׂB
	BBandor(bb_sum, BB_WSILVER, b_silver_attacks[sq_drop]);
	BBandor(bb_sum, BB_WTGOLD, b_gold_attacks[sq_drop]);
	// pAn...
	OCC(bb);
	bb = bishopAttacks(bb, sq_drop);
	BBandor(bb_sum, BB_W_BH, bb);
	// A...
	OCC(bb);
	bb = rookAttacks(bb, sq_drop);
	BBandor(bb_sum, BB_W_RD, bb);
	// ̗Ɣnsq̗̉̈ʒuɂ邩ׂB
	BBor(bb, BB_WHORSE, BB_WDRAGON);
	BBandor(bb_sum, bb, king_attacks[sq_drop]);

	while (BBToU(bb_sum))
	{
		ifrom = FirstOne(bb_sum);
		Xor(ifrom, bb_sum);

		// ifrom̈ʒűsq_dropɑłƂɋ󂫉ɂȂ邩ǂׂB
		// 󂫉ɂȂȂΑłl݂ɂȂ邱Ƃ͂ȂB
		if (DiscoverWK(ifrom, sq_drop)) { continue; }
		return 0;
	}

	iwk = SQ_WKING;
	iret = 1;
	Xor(sq_drop, BB_BOCCUPY); // BOCCUPYsq_drop̃rbg1

							  // bb_move :@ʂ̈ړ\ȃ}Xڂi[
	BBNotAnd(bb_move, king_attacks[iwk], BB_WOCCUPY);
	while (BBToU(bb_move))
	{
		ito = FirstOne(bb_move);

		// ̋ʂitoֈړƂɁA̋ɂĎĂ܂ȂׂB
		// itoֈړƂɐ̋Ɏ邱ƂȂꍇl݂ł͂ȂB
		// đłl݂ɂ͂ȂȂ̂falseԂB
		if (!is_white_attacked(ptree, ito))
		{
			iret = 0;
			break;
		}
		Xor(ito, bb_move);
	}

	// sq_drop̃rbg0
	Xor(sq_drop, BB_BOCCUPY);

	return iret;
}


int CONV
is_mate_w_pawn_drop(tree_t * restrict ptree, int sq_drop)
{
	bitboard_t bb, bb_sum, bb_move;
	int ibk, ito, ifrom, iret, idirec;

	BBand(bb_sum, BB_BKNIGHT, w_knight_attacks[sq_drop]);

	BBandor(bb_sum, BB_BSILVER, w_silver_attacks[sq_drop]);
	BBandor(bb_sum, BB_BTGOLD, w_gold_attacks[sq_drop]);

	OCC(bb);
	bb = bishopAttacks(bb, sq_drop);
	BBandor(bb_sum, BB_B_BH, bb);

	OCC(bb);
	bb = rookAttacks(bb, sq_drop);
	BBandor(bb_sum, BB_B_RD, bb);

	BBor(bb, BB_BHORSE, BB_BDRAGON);
	BBandor(bb_sum, bb, king_attacks[sq_drop]);

	while (BBToU(bb_sum))
	{
		ifrom = FirstOne(bb_sum);
		Xor(ifrom, bb_sum);

		if (DiscoverBK(ifrom, sq_drop)) { continue; }
		return 0;
	}

	ibk = SQ_BKING;
	iret = 1;
	Xor(sq_drop, BB_WOCCUPY);

	BBNotAnd(bb_move, king_attacks[ibk], BB_BOCCUPY);
	while (BBToU(bb_move))
	{
		ito = FirstOne(bb_move);
		if (!is_black_attacked(ptree, ito))
		{
			iret = 0;
			break;
		}
		Xor(ito, bb_move);
	}

	Xor(sq_drop, BB_WOCCUPY);

	return iret;
}

// sq̈ʒuɗĂ邷ׂĂ̋̈ʒui܂ށjbb_retԂ
bitboard_t CONV
attacks_to_piece(tree_t * restrict ptree, int sq)
{
	bitboard_t bb_ret, bb_attacks, bb, occ;
	OCC(occ);

	BBIni(bb_ret);
	if (sq % 9 != 8 && BOARD[sq + 1] == pawn) {
		bb_ret = abb_mask[sq + 1];
	}
	if (sq % 9 != 0 && (BOARD[sq - 1] == (pawn & 0x000F))) {
		BBor(bb_ret, bb_ret, abb_mask[sq - 1]);
	}

	BBandor(bb_ret, BB_BKNIGHT, w_knight_attacks[sq]);
	BBandor(bb_ret, BB_WKNIGHT, b_knight_attacks[sq]);
	BBandor(bb_ret, BB_BSILVER, w_silver_attacks[sq]);
	BBandor(bb_ret, BB_WSILVER, b_silver_attacks[sq]);
	BBandor(bb_ret, BB_BTGOLD, w_gold_attacks[sq]);
	BBandor(bb_ret, BB_WTGOLD, b_gold_attacks[sq]);

	BBor(bb, BB_B_HDK, BB_W_HDK);
	BBandor(bb_ret, bb, king_attacks[sq]);

	BBor(bb, BB_B_BH, BB_W_BH);
	OCC(bb_attacks);
	bb_attacks = bishopAttacks(bb_attacks, sq);
	BBandor(bb_ret, bb, bb_attacks);

	BBor(bb, BB_B_RD, BB_W_RD);
	BBandor(bb_ret, bb, AttackRank(sq, occ));
	BBandor(bb, BB_BLANCE, plus_rays[sq]);
	BBandor(bb, BB_WLANCE, minus_rays[sq]);
	BBandor(bb_ret, bb, AttackFile(sq));

	return bb_ret;
}

bitboard_t b_attacks_to_piece(tree_t *ptree, int sq) {
	bitboard_t bb_ret, bb_attacks, bb, occ;
	OCC(occ);

	BBIni(bb_ret);
	if (sq % 9 != 8 && BOARD[sq + 1] == pawn) {
		bb_ret = abb_mask[sq + 1];
	}

	BBandor(bb_ret, BB_BKNIGHT, w_knight_attacks[sq]);
	BBandor(bb_ret, BB_BSILVER, w_silver_attacks[sq]);
	BBandor(bb_ret, BB_BTGOLD, w_gold_attacks[sq]);
	BBandor(bb_ret, BB_B_HDK, king_attacks[sq]);

	bb_attacks = bishopAttacks(occ, sq);
	BBandor(bb_ret, BB_B_BH, bb_attacks);

	bb = BB_B_RD;
	BBandor(bb_ret, bb, AttackRank(sq, occ));
	BBandor(bb, BB_BLANCE, minus_rays[sq]);
	BBandor(bb_ret, bb, AttackFile(sq));

	return bb_ret;
}

bitboard_t w_attacks_to_piece(tree_t *ptree, int sq) {
	bitboard_t bb_ret, bb_attacks, bb, occ;
	OCC(occ);

	BBIni(bb_ret);
	if (sq % 9 != 0 && BOARD[sq - 1] == pawn + enemy) {
		bb_ret = abb_mask[sq - 1];
	}

	BBandor(bb_ret, BB_WKNIGHT, b_knight_attacks[sq]);
	BBandor(bb_ret, BB_WSILVER, b_silver_attacks[sq]);
	BBandor(bb_ret, BB_WTGOLD, b_gold_attacks[sq]);
	BBandor(bb_ret, BB_W_HDK, king_attacks[sq]);

	bb_attacks = bishopAttacks(occ, sq);
	BBandor(bb_ret, BB_W_BH, bb_attacks);

	bb = BB_W_RD;
	BBandor(bb_ret, bb, AttackRank(sq, occ));
	BBandor(bb, BB_WLANCE, plus_rays[sq]);
	BBandor(bb_ret, bb, AttackFile(sq));

	return bb_ret;
}

/*                     
0  0000000  0        1  1111111  1
1  1111111  1        1  1111111  1
1  1111111  1        1  1111111  1
1  1111111  1        1  1111111  1
1  1111111  1        1  1111111  1
1  1111111  1        1  1111111  1
1  1111111  1        1  1111111  1
1  1111111  1        1  1111111  1
1  1111111  1        0  0000000  0
p[2]  p[1]  p[0]     p[2]  p[1]  p[0]
255  460... 255      510   920... 510
*/

bitboard_t FUattacks(bitboard_t b, int turn) {
	bitboard_t FU_attacks, fumask;
	if (turn) { // Ȃ
		fumask.p[0] = 255ULL; // p[0]̕uꏊ
		fumask.p[1] = 4602661192559623935ULL; // p[1]̕uꏊ
		fumask.p[2] = 255ULL; //p[2]̕uꏊ

		FU_attacks.p[0] = b.p[0] & fumask.p[0]; // b.p[0]̈̕ʒu
		FU_attacks.p[1] = b.p[1] & fumask.p[1]; // b.p[1]̈̕ʒu
		FU_attacks.p[2] = b.p[2] & fumask.p[2]; // b.p[2]̈̕ʒu

		FU_attacks.p[0] = FU_attacks.p[0] << 1; // vmF bitZtȋC邯ǍĂ݂
		FU_attacks.p[1] = FU_attacks.p[1] << 1; // ̗̕𐶐
		FU_attacks.p[2] = FU_attacks.p[2] << 1;
	}
	else { // Ȃ
		fumask.p[0] = 510ULL;
		fumask.p[1] = 9205322385119247870ULL;
		fumask.p[2] = 510ULL;

		FU_attacks.p[0] = b.p[0] & fumask.p[0];
		FU_attacks.p[1] = b.p[1] & fumask.p[1];
		FU_attacks.p[2] = b.p[2] & fumask.p[2];

		FU_attacks.p[0] = FU_attacks.p[0] >> 1;
		FU_attacks.p[1] = FU_attacks.p[1] >> 1;
		FU_attacks.p[2] = FU_attacks.p[2] >> 1;
	}

	return FU_attacks; // bitboardreturn
}

/* p̗Zo(Magic bitboard)
@param occ: Ֆʏɂ
@param sq: p̈ʒu
*/
bitboard_t bishopAttacks(bitboard_t occ, int sq) {
	uint64 index = 0ULL;
	occ.p[1] &= mBishoptbl[sq].mask.p[1];

	index = transform(occ.p[1], mBishoptbl[sq].magic[0], mBishoptbl[sq].shift);

	return bishop_attacks[sq][index];
}

/* Ԃ̗Zo(Magic bitboard)
@param occ: Ֆʏɂ
@param sq: Ԃ̈ʒu
*/
bitboard_t rookAttacks(bitboard_t occ, int sq) {
	uint64 index = 0ULL, mask = 0ULL;

	// 1
	if (sq < 9) {
		occ.p[0] &= mNewRooktbl[sq].mask.p[0];
		occ.p[1] &= mNewRooktbl[sq].mask.p[1];

		index = transform2(occ.p[1], occ.p[0], mNewRooktbl[sq].magic[0], mNewRooktbl[sq].magic[1], mNewRooktbl[sq].shift);//Ԃ񂱂64rbgΉ

		return new_rook_attacks[sq][index];
	}
	else if (sq < 72) {


		index = transform3(occ.p[1] & mNewRooktbl[sq].mask.p[0],
			occ.p[1] & mNewRooktbl[sq].mask.p[1],
			mNewRooktbl[sq].magic[0],
			mNewRooktbl[sq].magic[1],
			mNewRooktbl[sq].shift
			);

		return new_rook_attacks[sq][index];
	}
	// 9
	else {
		occ.p[2] &= mNewRooktbl[sq].mask.p[2];
		occ.p[1] &= mNewRooktbl[sq].mask.p[1];

		index = transform2(occ.p[1], occ.p[2], mNewRooktbl[sq].magic[0], mNewRooktbl[sq].magic[1], mNewRooktbl[sq].shift);//Ԃ񂱂64rbgΉ

		return new_rook_attacks[sq][index];
	}
}
