#include <climits>
#include "shogi.h"

// ŉʃrbgscančŏ1łbit
int CONV last_one012(unsigned long long u2, unsigned long long u1, unsigned long long u0)
{
#if defined(USE_32_BIT_MULTIPLICATIONS)
	int index = 0;
	unsigned long long top;


	if (u0) {
		do {
			top = 1ULL << index;
			if (top&u0) {
				return index;
			}
			index++;
		} while (index <= 8);
	}

	if (u1) {
		do {
			top = 1ULL << index;
			if (top & u1) {
				return index + 9;
			}
			index++;
		} while (index <= 62);
	}

	if (u2) {
		do {
			top = 1ULL << index;
			if (top & u2) {
				return index + 72;
			}
			index++;
		} while (index <= 8);
	}
	return 0;
#else
	unsigned long index;
	if (_BitScanForward64(&index, u2)) {
		return index + 72;
	}
	if (_BitScanForward64(&index, u1)) {
		return index + 9;
	}
	_BitScanForward64(&index, u0);
	return index;
#endif

}

// ŏʃrbgscančŏ1łbit
int CONV first_one012(unsigned long long u2, unsigned long long u1, unsigned long long u0)
{
#if defined(USE_32_BIT_MULTIPLICATIONS)
	int index = 0;
	unsigned long long top = 0;

	if (u0) {
		top = 256ULL;
		do {
			if ((top >> index) & u0) {
				return 8 - index;
			}
			index++;
		} while (index <= 8);
	}

	if (u1) {
		top = 4611686018427387904ULL;
		do {
			if ((top >> index) & u1) {
				return 71 - index;
			}
			index++;
		} while (index <= 62);
	}

	if (u2) {
		top = 256ULL;
		do {
			if ((top >> index) & u2) {
				return 80 - index;
			}
			index++;
		} while (index <= 8);
	}
	return 0;
#else

	DWORD index;
	if (_BitScanReverse64(&index, u0)) {
		return index;
	}
	if (_BitScanReverse64(&index, u1)) {
		return index + 9;
	}
	_BitScanReverse64(&index, u2);
	return index + 72;
#endif
}

int CONV bitcount(unsigned long long u0, unsigned long long u1, unsigned long long u2)
{
	int c = 0;
	while (u0) {
		++c;
		u0 &= u0 - 1ULL;
	}
	while (u1) {
		++c;
		u1 &= u1 - 1ULL;
	}
	while (u2) {
		++c;
		u2 &= u2 - 1ULL;
	}
	return c;
}

void print_BB(const bitboard_t * bb)
{
	uint64 init_llu = 0x8000000000000000ui64;
	uint64 bit = init_llu;

	int i, cnt;

	printf("print_bb:\n");
	printf("      \n");
	printf("        \n");
	for (i = 2; 0 <= i; i--) {
		cnt = 0;
		for (bit = init_llu; bit != 0; bit >>= 1) {
#if 1
			if (((i == 0 || i == 2) && 54 < cnt)
				|| (i == 1 && cnt))
			{
				if (bb->p[i] & bit)
					printf("1");
				else
					printf("0");

				if (cnt && !(cnt % 9) && cnt <= 63) {
					if (i == 2)
						printf("  H");
					if (i == 0)
						printf("@");
					printf("\n");
				}
			}
			cnt++;
#else
			if (bb->p[i] & bit)
				printf("1");
			else
				printf("0");
#endif			
		}
		printf("\n");
	}
	printf("\n");
}


/* bitboard̒g2i\
@ Տ̈ʒuɕёւDȂ1,ȂȂ0ŕ\L

  */
void print_BB2(const bitboard_t * bb)
{
	uint64 init_llu = 0x8000000000000000ui64;
	uint64 bit = init_llu;

	int i, j, cnt;
	int board[3][63];

	//init
	for (i = 0; i<3; i++)
		for (j = 0; j<63; j++)
			board[i][j] = 0;

	for (i = 2; 0 <= i; i--) {
		cnt = 0;
		j = 0;
		for (bit = init_llu; bit != 0; bit >>= 1) {
			if (((i == 0 || i == 2) && 54 < cnt)
				|| (i == 1 && cnt))
			{
				if (bb->p[i] & bit) {
					board[i][j] = 1;
				}
				else {
					board[i][j] = 0;
				}

				j++;
			}
			cnt++;
		}
	}

	//\
	printf("print_bb:\n");
	printf("        \n");
	for (j = 8; 0 <= j; j--) {
		for (i = 2; 0 <= i; i--) {
			cnt = 0;
			if (i == 1) {
				cnt = j;
				while (cnt < 63) {
					printf("%ld", board[i][cnt]);
					cnt += 9;
				}
			}
			else {
				printf("%ld", board[i][j]);
			}
		}
		if (j == 8)
			printf("");
		printf("\n");
	}
	printf("\n");
}


/* uint64̒gbit2i\L
* @param bit : \LΏ
* @param sw : XCb`D1Ȃ炷ׂĕ\C0Ȃ牺9bit̂ݕ\
*/
void print_ui64(const uint64 bit, const int sw)
{
	uint64 init_llu = 0x8000000000000000ui64;
	uint64 tmp = init_llu;

	int cnt = 0;

	//printf("print_uint64:\n");
	for (tmp = init_llu; tmp != 0; tmp >>= 1) {
#if 0
		if ((sw && cnt)
			|| (!sw && 54 < cnt))
		{
			if (bit & tmp)
				printf("1");
			else
				printf("0");
		}

		if (sw && (cnt && !(cnt % 9) && cnt <= 63))
			printf("\n");

		cnt++;
#else
		if (bit & tmp) {
			printf("1");
		}
		else
			printf("0");
#endif			
	}
	printf("\n");
}
