#include <stdio.h>
#include <stdlib.h>
#include "shogi.h"
#include "platform.h"

GMagic mBishoptbl[81];
GMagic mRooktbl[81];
GMagic mNewRooktbl[81];

unsigned char adirec[nsquare][nsquare];
bitboard_t abb_mask[nsquare];
bitboard_t file_attacks[nsquare][128];
bitboard_t rank_attacks[nsquare][128];
bitboard_t obstacle[nsquare][nsquare];
bitboard_t plus_rays[nsquare];
bitboard_t minus_rays[nsquare];
bitboard_t black_mask_rank1;
bitboard_t black_mask_rank2;
bitboard_t white_mask_rank1;
bitboard_t white_mask_rank2;

bitboard_t b_knight_attacks[nsquare];
bitboard_t w_knight_attacks[nsquare];
bitboard_t b_silver_attacks[nsquare];
bitboard_t w_silver_attacks[nsquare];
bitboard_t b_gold_attacks[nsquare];
bitboard_t w_gold_attacks[nsquare];
bitboard_t king_attacks[nsquare];
bitboard_t bishop_attacks[nsquare][16384];
bitboard_t rook_attacks[nsquare][16384];
bitboard_t new_rook_attacks[nsquare][16384];

slide_t slide[nsquare];
int p_value[32];

bool Infinite;							// vlԂǂ
unsigned long remainTime;				// c莞
unsigned long byoyomiTime;				// bǂ
unsigned long incrementTime;			// tBbV[[pZ

//SFEN`p
const char *rankSFENNameArray[] = {
	"", "a", "b", "c", "d", "e", "f", "g", "h", "i",
};

const char *mochiGomaSFENNameArray[] = {
	"  ", "P", "L", "N", "S", "G", "B", "R"
};

//ǖʂ\
const int  init_board[81] = {
	WKY, EMP, WFU, EMP, EMP, EMP, BFU, EMP, BKY,  // 18,  0, 17, 0, 0, 0, 1, 0, 2
	WKE, WKA, WFU, EMP, EMP, EMP, BFU, BHI, BKE,  // 19, 22, 17, 0, 0, 0, 1, 7, 3
	WGI, EMP, WFU, EMP, EMP, EMP, BFU, EMP, BGI,  // 20,  0, 17, 0, 0, 0, 1, 0, 4
	WKI, EMP, WFU, EMP, EMP, EMP, BFU, EMP, BKI,  // 21,  0, 17, 0, 0, 0, 1, 0, 5
	WOU, EMP, WFU, EMP, EMP, EMP, BFU, EMP, BOU,  // 24,  0, 17, 0, 0, 0, 1, 0, 8
	WKI, EMP, WFU, EMP, EMP, EMP, BFU, EMP, BKI,  // 21,  0, 17, 0, 0, 0, 1, 0, 5
	WGI, EMP, WFU, EMP, EMP, EMP, BFU, EMP, BGI,  // 20,  0, 17, 0, 0, 0, 1, 0, 4
	WKE, WHI, WFU, EMP, EMP, EMP, BFU, BKA, BKE,  // 19, 23, 17, 0, 0, 0, 1, 6, 3
	WKY, EMP, WFU, EMP, EMP, EMP, BFU, EMP, BKY   // 18,  0, 17, 0, 0, 0, 1, 0, 2
};

bitboard_t bb_set_mask(int sq)
{
	bitboard_t bb;
	BBIni(bb);
	if (sq > 71) {
		bb.p[2] = 1ULL << (sq - 72);
	}
	else if (sq > 8) {
		bb.p[1] = 1ULL << (sq - 9);
	}
	else {
		bb.p[0] = 1ULL << sq;
	}
	return bb;
}

const int BitTable[64] = {
	63, 30, 3, 32, 25, 41, 22, 33, 15,
	50, 42, 13, 11, 53, 19, 34, 61, 29,
	2, 51, 21, 43, 45, 10, 18, 47, 1,
	54, 9, 57, 0, 35, 62, 31, 40, 4,
	49, 5, 52, 26, 60, 6, 23, 44, 46,
	27, 56, 16, 7, 39, 48, 24, 59, 14,
	12, 55, 38, 28, 58, 20, 37, 17, 36, 8
};

int RBits[64] = {//c^QꂩW܂
	13, 12, 12, 12, 12, 12, 12, 12, 13,
	13, 12, 12, 12, 12, 12, 12, 12, 13,
	13, 12, 12, 12, 12, 12, 12, 12, 13,
	13, 12, 12, 12, 12, 12, 12, 12, 13,
	13, 12, 12, 12, 12, 12, 12, 12, 13,
	13, 12, 12, 12, 12, 12, 12, 12, 13,
	13, 12, 12, 12, 12, 12, 12, 12, 13,
};

int BBits[64] = {//̂Ɠ
	6, 6, 6, 6, 6, 6, 6, 6, 6,
	6, 6, 8, 8, 8, 8, 8, 6, 6,
	6, 6, 8, 11, 10, 11, 8, 6, 6,
	6, 6, 8, 10, 12, 10, 8, 6, 6,
	6, 6, 8, 11, 10, 11, 8, 6, 6,
	6, 6, 8, 8, 8, 8, 8, 6, 6,
	6, 6, 6, 6, 6, 6, 6, 6, 6,
};

int sideRBit[9] = {
	7, 6, 6, 6, 6, 6, 6, 6, 7
};

int sideBBit[9] = {
	7, 6, 6, 6, 6, 6, 6, 6, 7
};
