#include "bitboard.h"
#include "shogi.h"

// vZ
int CONV eval_material(const tree_t * restrict ptree)
{
	int material, itemp;

	itemp = BitCount(BB_BPAWN);
	itemp += (int)I2HandPawn(HAND_B);
	itemp -= BitCount(BB_WPAWN);
	itemp -= (int)I2HandPawn(HAND_W);
	material = itemp * p_value[15 + pawn]; /* 1̕]l */

	itemp = BitCount(BB_BLANCE);
	itemp += (int)I2HandLance(HAND_B);
	itemp -= BitCount(BB_WLANCE);
	itemp -= (int)I2HandLance(HAND_W);
	material += itemp * p_value[15 + lance];

	itemp = BitCount(BB_BKNIGHT);
	itemp += (int)I2HandKnight(HAND_B);
	itemp -= BitCount(BB_WKNIGHT);
	itemp -= (int)I2HandKnight(HAND_W);
	material += itemp * p_value[15 + knight];

	itemp = BitCount(BB_BSILVER);
	itemp += (int)I2HandSilver(HAND_B);
	itemp -= BitCount(BB_WSILVER);
	itemp -= (int)I2HandSilver(HAND_W);
	material += itemp * p_value[15 + silver];

	itemp = BitCount(BB_BGOLD);
	itemp += (int)I2HandGold(HAND_B);
	itemp -= BitCount(BB_WGOLD);
	itemp -= (int)I2HandGold(HAND_W);
	material += itemp * p_value[15 + gold];

	itemp = BitCount(BB_BBISHOP);
	itemp += (int)I2HandBishop(HAND_B);
	itemp -= BitCount(BB_WBISHOP);
	itemp -= (int)I2HandBishop(HAND_W);
	material += itemp * p_value[15 + bishop];

	itemp = BitCount(BB_BROOK);
	itemp += (int)I2HandRook(HAND_B);
	itemp -= BitCount(BB_WROOK);
	itemp -= (int)I2HandRook(HAND_W);
	material += itemp * p_value[15 + rook];

	itemp = BitCount(BB_BPRO_PAWN);
	itemp -= BitCount(BB_WPRO_PAWN);
	material += itemp * p_value[15 + pro_pawn];

	itemp = BitCount(BB_BPRO_LANCE);
	itemp -= BitCount(BB_WPRO_LANCE);
	material += itemp * p_value[15 + pro_lance];

	itemp = BitCount(BB_BPRO_KNIGHT);
	itemp -= BitCount(BB_WPRO_KNIGHT);
	material += itemp * p_value[15 + pro_knight];

	itemp = BitCount(BB_BPRO_SILVER);
	itemp -= BitCount(BB_WPRO_SILVER);
	material += itemp * p_value[15 + pro_silver];

	itemp = BitCount(BB_BHORSE);
	itemp -= BitCount(BB_WHORSE);
	material += itemp * p_value[15 + horse];

	itemp = BitCount(BB_BDRAGON);
	itemp -= BitCount(BB_WDRAGON);
	material += itemp * p_value[15 + dragon];

	return material;
}
