#include <cstdio>
#include <cstdlib>

#include "shogi.h"
#include "bitboard.h"

int b_king_evasion(tree_t *ptree, int pmove) {

	bitboard_t bb_buf, bb_checker, bb_blocker, bb_target, bb_piece, occ;
	bitboard_t bb_rank1, bb_rank2;
	bitboard_t pawn_attack;
	uint64 file_inf;
	int nchecker, nhand, sq_bk, sq_check, idirec, nolance, noknight;
	int from, to, cap_piece, move_piece, drop_file;
	int type_hand[6];
	unsigned int hand_inf;

	BBor(occ, BB_BOCCUPY, BB_WOCCUPY);

	// ē
	sq_bk = SQ_BKING;

	Xor(sq_bk, BB_BOCCUPY);

	BBNot(bb_buf, BB_BOCCUPY);
	BBand(bb_buf, king_attacks[sq_bk], bb_buf); // ̍słꏊ
	while (BBToU(bb_buf)) {
		to = FirstOne(bb_buf);
		if (!is_black_attacked(ptree, to)) { // ړ悪肩ǂ
			ptree->Move[pmove++] = SET_MOVE(to, sq_bk, 0, king, BOARD[to] & 0x000F);
		}
		Xor(to, bb_buf);
	}

	Xor(sq_bk, BB_BOCCUPY);

	bb_checker = w_attacks_to_piece(ptree, sq_bk);
	nchecker = BitCount(bb_checker); // Ă̐𐔂Ă

									 // ͓̂ݐ
	if (nchecker == 2) {
		return pmove;
	}

	// ̋𓮂ĉ󂯂
	sq_check = FirstOne(bb_checker);
	bb_blocker = obstacle[sq_check][sq_bk]; // ĂƉ̊Ԃ̃}X
	BBor(bb_target, bb_blocker, bb_checker);

	// 
	FU_ATTACKS(pawn_attack, BB_BPAWN, black);
	BBand(bb_buf, bb_target, pawn_attack);
	while (BBToU(bb_buf)) {
		to = FirstOne(bb_buf);
		Xor(to, bb_buf);
		from = to + 1;
		idirec = (int)adirec[sq_bk][from]; // ƈړ̕֌W
		if (!idirec || !pinned_black_king(ptree, from, idirec)) { // ړpinĂȂ
			cap_piece = BOARD[to] & 0x000F;
			if (((to % 9) >= 0) && ((to % 9) <= 2)) {
				ptree->Move[pmove++] = SET_MOVE(to, from, 1, pawn, cap_piece);
			}
			else {
				ptree->Move[pmove++] = SET_MOVE(to, from, 0, pawn, cap_piece);
			}
		}
	}

	// 
	bb_piece = BB_BLANCE;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);
		bb_buf = AttackFile(from);
		BBand(bb_buf, bb_buf, plus_rays[from]);
		BBand(bb_buf, bb_buf, bb_target);
		if (!BBToU(bb_buf)) {
			continue;
		}

		idirec = (int)adirec[sq_bk][from];
		if (!idirec || !pinned_black_king(ptree, from, idirec)) {
			do {
				to = FirstOne(bb_buf);
				Xor(to, bb_buf);
				cap_piece = BOARD[to] & 0x000F;
				if (to % 9 != 0) {
					ptree->Move[pmove++] = SET_MOVE(to, from, 0, lance, cap_piece);
				}
				if (((to % 9) >= 0) && ((to % 9) <= 2)) {
					ptree->Move[pmove++] = SET_MOVE(to, from, 1, lance, cap_piece);
				}
			} while (BBToU(bb_buf));
		}
	}

	// j
	bb_piece = BB_BKNIGHT;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);
		BBand(bb_buf, b_knight_attacks[from], bb_target);
		if (!BBToU(bb_buf)) {
			continue;
		}
		idirec = (int)adirec[sq_bk][from];
		if (!idirec || !pinned_black_king(ptree, from, idirec)) {
			do {
				to = FirstOne(bb_buf);
				Xor(to, bb_buf);
				cap_piece = BOARD[to] & 0x000F;
				if (to % 9 >= 2) { // 1, 2iɌjn͋Ă͂ȂȂ
					ptree->Move[pmove++] = SET_MOVE(to, from, 0, knight, cap_piece);
				}
				if (((to % 9) >= 0) && ((to % 9) <= 2)) {
					ptree->Move[pmove++] = SET_MOVE(to, from, 1, knight, cap_piece);
				}
			} while (BBToU(bb_buf));
		}
	}

	// 
	bb_piece = BB_BSILVER;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);

		BBand(bb_buf, b_silver_attacks[from], bb_target);
		if (!BBToU(bb_buf)) {
			continue;
		}

		idirec = (int)adirec[sq_bk][from];
		if (!idirec || !pinned_black_king(ptree, from, idirec)) {
			do {
				to = FirstOne(bb_buf);
				Xor(to, bb_buf);
				cap_piece = BOARD[to] & 0x000F;
				ptree->Move[pmove++] = SET_MOVE(to, from, 0, silver, cap_piece);
				if (((((from % 9) >= 0) && ((from % 9) <= 2)) || (((to % 9) >= 0) && ((to % 9) <= 2)))) {
					ptree->Move[pmove++] = SET_MOVE(to, from, 1, silver, cap_piece);
				}
			} while (BBToU(bb_buf));
		}
	}

	// 
	bb_piece = BB_BTGOLD;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);

		BBand(bb_buf, b_gold_attacks[from], bb_target);
		if (!BBToU(bb_buf)) {
			continue;
		}
		idirec = (int)adirec[sq_bk][from];
		if (!idirec || !pinned_black_king(ptree, from, idirec)) {
			do {
				to = FirstOne(bb_buf);
				Xor(to, bb_buf);
				cap_piece = BOARD[to] & 0x000F;
				move_piece = BOARD[from] & 0x000F;
				ptree->Move[pmove++] = SET_MOVE(to, from, 0, move_piece, cap_piece);
			} while (BBToU(bb_buf));
		}

	}

	// p
	bb_piece = BB_BBISHOP;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);

		bb_buf = bishopAttacks(occ, from);
		BBand(bb_buf, bb_buf, bb_target);
		if (!BBToU(bb_buf)) {
			continue;
		}
		idirec = (int)adirec[sq_bk][from];
		if (!idirec || !pinned_black_king(ptree, from, idirec)) {
			do {
				to = FirstOne(bb_buf);
				Xor(to, bb_buf);

				cap_piece = BOARD[to] & 0x000F;
				ptree->Move[pmove++] = SET_MOVE(to, from, 0, bishop, cap_piece);
				if (((((from % 9) >= 0) && ((from % 9) <= 2)) || (((to % 9) >= 0) && ((to % 9) <= 2)))) {
					ptree->Move[pmove++] = SET_MOVE(to, from, 1, bishop, cap_piece);
				}
			} while (BBToU(bb_buf));
		}
	}

	// 
	bb_piece = BB_BROOK;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);

		bb_buf = rookAttacks(occ, from);
		BBand(bb_buf, bb_buf, bb_target);
		if (!BBToU(bb_buf)) {
			continue;
		}
		idirec = (int)adirec[sq_bk][from];
		if (!idirec || !pinned_black_king(ptree, from, idirec)) {
			do {
				to = FirstOne(bb_buf);
				Xor(to, bb_buf);

				cap_piece = BOARD[to] & 0x000F;
				ptree->Move[pmove++] = SET_MOVE(to, from, 0, rook, cap_piece);
				if (((((from % 9) >= 0) && ((from % 9) <= 2)) || (((to % 9) >= 0) && ((to % 9) <= 2)))) {
					ptree->Move[pmove++] = SET_MOVE(to, from, 1, rook, cap_piece);

				}
			} while (BBToU(bb_buf));
		}
	}

	// n
	bb_piece = BB_BHORSE;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);

		bb_buf = bishopAttacks(occ, from);
		BBor(bb_buf, bb_buf, king_attacks[from]);
		BBand(bb_buf, bb_buf, bb_target);
		if (!BBToU(bb_buf)) {
			continue;
		}
		idirec = (int)adirec[sq_bk][from];
		if (!idirec || !pinned_black_king(ptree, from, idirec)) {
			do {
				to = FirstOne(bb_buf);
				Xor(to, bb_buf);
				cap_piece = BOARD[to] & 0x000F;
				ptree->Move[pmove++] = SET_MOVE(to, from, 0, horse, cap_piece);
			} while (BBToU(bb_buf));
		}
	}

	// 
	bb_piece = BB_BDRAGON;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);

		bb_buf = rookAttacks(occ, from);
		BBor(bb_buf, bb_buf, king_attacks[from]);
		BBand(bb_buf, bb_buf, bb_target);
		if (!BBToU(bb_buf)) {
			continue;
		}
		idirec = (int)adirec[sq_bk][from];
		if (!idirec || !pinned_black_king(ptree, from, idirec)) {
			do {
				to = FirstOne(bb_buf);
				Xor(to, bb_buf);
				cap_piece = BOARD[to] & 0x000F;
				ptree->Move[pmove++] = SET_MOVE(to, from, 0, dragon, cap_piece);
			} while (BBToU(bb_buf));
		}
	}

	// 
	if (!HAND_B) { // Ȃ
		return pmove;
	}
	if (!BBToU(bb_blocker)) { // uꏊȂ
		return pmove;
	}

	bb_target = bb_blocker;
	hand_inf = HAND_B;
	nhand = 0;

	// j`Ăzɓ
	if (IsHandKnight(hand_inf)) {
		type_hand[nhand++] = knight;
	}
	noknight = nhand;
	if (IsHandLance(hand_inf)) {
		type_hand[nhand++] = lance;
	}
	nolance = nhand;
	if (IsHandSilver(hand_inf)) {
		type_hand[nhand++] = silver;
	}
	if (IsHandGold(hand_inf)) {
		type_hand[nhand++] = gold;
	}
	if (IsHandBishop(hand_inf)) {
		type_hand[nhand++] = bishop;
	}
	if (IsHandRook(hand_inf)) {
		type_hand[nhand++] = rook;
	}

	// iQ`FbNj
	if (IsHandPawn(hand_inf)) {
		while (BBToU(bb_blocker)) {
			to = FirstOne(bb_blocker);
			Xor(to, bb_blocker);

			drop_file = to / 9;
			if (drop_file == 0) {
				file_inf = BB_BPAWN.p[0];
			}
			else if (drop_file == 8) {
				file_inf = BB_BPAWN.p[2];
			}
			else {
				file_inf = (BB_BPAWN.p[1] >> ((drop_file - 1) * 9)) & 0x01FF;
			}

			if (BOARD[to] == empty && file_inf <= 0) {
				ptree->Move[pmove++] = SET_MOVE(to, drop_pawn, 0, FU, 0);
			}
		}
	}

	// 1, 2iڂŋ̑łĂƂ
	BBand(bb_rank1, bb_target, black_mask_rank1);
	BBand(bb_rank2, bb_target, black_mask_rank2);

	// 3iځ`9iڂ݂̂𒲂ׂ邽߂1`2iڂ̃rbg0ɂ
	bb_target.p[0] &= 0x1FCU;
	bb_target.p[1] &= 0x7F3F9FCFE7F3F9FCU;
	bb_target.p[2] &= 0x1FCU;

	// 3~9iڂ͂œ
	while (BBToU(bb_target)) {
		to = FirstOne(bb_target);
		for (int i = 0; i < nhand; i++) {
			ptree->Move[pmove++] = SET_MOVE(to, 80 + type_hand[i], 0, type_hand[i], 0);
		}
		Xor(to, bb_target);
	}

	// 2iڂ͌jnē
	while (BBToU(bb_rank2)) {
		to = FirstOne(bb_rank2);
		for (int i = noknight; i < nhand; i++) {
			ptree->Move[pmove++] = SET_MOVE(to, 80 + type_hand[i], 0, type_hand[i], 0);
		}
		Xor(to, bb_rank2);
	}

	// 1iڂ͍Ԃē
	while (BBToU(bb_rank1)) {
		to = FirstOne(bb_rank1);
		for (int i = nolance; i < nhand; i++) {
			ptree->Move[pmove++] = SET_MOVE(to, 80 + type_hand[i], 0, type_hand[i], 0);
		}
		Xor(to, bb_rank1);
	}
	return pmove;
}

int w_king_evasion(tree_t *ptree, int pmove) {

	bitboard_t bb_buf, bb_checker, bb_blocker, bb_target, bb_piece, occ;
	bitboard_t bb_rank1, bb_rank2;
	bitboard_t pawn_attack;
	uint64 file_inf;
	int nchecker, nhand, sq_wk, sq_check, idirec, nolance, noknight;
	int from, to, cap_piece, move_piece, drop_file;
	int type_hand[6];
	unsigned int hand_inf;

	BBor(occ, BB_BOCCUPY, BB_WOCCUPY);
	sq_wk = SQ_WKING;

	// ē
	Xor(sq_wk, BB_WOCCUPY);
	BBNot(bb_buf, BB_WOCCUPY);
	BBand(bb_buf, king_attacks[sq_wk], bb_buf); // ̍słꏊ
	while (BBToU(bb_buf)) {
		to = FirstOne(bb_buf);
		if (!is_white_attacked(ptree, to)) { // ړ悪肩ǂ
			ptree->Move[pmove++] = SET_MOVE(to, sq_wk, 0, king, BOARD[to]);
		}
		Xor(to, bb_buf);
	}

	Xor(sq_wk, BB_WOCCUPY);

	bb_checker = b_attacks_to_piece(ptree, sq_wk);
	nchecker = BitCount(bb_checker); // Ă̐𐔂Ă

									 // ͓̂ݐ
	if (nchecker == 2) {
		return pmove;
	}

	// ̋𓮂ĉ󂯂
	sq_check = FirstOne(bb_checker);
	bb_blocker = obstacle[sq_check][sq_wk]; // ĂƉ̊Ԃ̃}X
	BBor(bb_target, bb_blocker, bb_checker);

	// ȉÂƂƓ
	FU_ATTACKS(pawn_attack, BB_WPAWN, white);
	BBand(bb_buf, bb_target, pawn_attack); // Ŗh邩
	while (BBToU(bb_buf)) {
		to = FirstOne(bb_buf);
		Xor(to, bb_buf);
		from = to - 1;
		idirec = (int)adirec[sq_wk][from]; // ƈړ̕֌W
		if (!idirec || !pinned_white_king(ptree, from, idirec)) { // ړpinĂȂ
			cap_piece = BOARD[to] & 0x000F;
			if ((to % 9) >= 6) {
				ptree->Move[pmove++] = SET_MOVE(to, from, 1, pawn, cap_piece);
			}
			else {
				ptree->Move[pmove++] = SET_MOVE(to, from, 0, pawn, cap_piece);
			}
		}
	}

	bb_piece = BB_WLANCE;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);
		bb_buf = AttackFile(from);
		BBand(bb_buf, bb_buf, minus_rays[from]);
		BBand(bb_buf, bb_buf, bb_target);

		idirec = (int)adirec[sq_wk][from];
		if (!BBToU(bb_buf)) {
			continue;
		}
		if (!idirec || !pinned_white_king(ptree, from, idirec)) {
			do {
				to = FirstOne(bb_buf);
				Xor(to, bb_buf);
				cap_piece = BOARD[to] & 0x000F;
				if ((to % 9) != 8) {
					ptree->Move[pmove++] = SET_MOVE(to, from, 0, lance, cap_piece);
				}
				if ((to % 9) >= 6) {
					ptree->Move[pmove++] = SET_MOVE(to, from, 1, lance, cap_piece);
				}
			} while (BBToU(bb_buf));
		}
	}

	bb_piece = BB_WKNIGHT;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);
		BBand(bb_buf, w_knight_attacks[from], bb_target);
		if (!BBToU(bb_buf)) {
			continue;
		}
		idirec = (int)adirec[sq_wk][from];
		if (!idirec || !pinned_white_king(ptree, from, idirec)) {
			do {
				to = FirstOne(bb_buf);
				Xor(to, bb_buf);
				cap_piece = BOARD[to] & 0x000F;
				if ((to % 9) <= 6) {
					ptree->Move[pmove++] = SET_MOVE(to, from, 0, knight, cap_piece);
				}
				if ((to % 9) >= 6) {
					ptree->Move[pmove++] = SET_MOVE(to, from, 1, knight, cap_piece);
				}
			} while (BBToU(bb_buf));
		}
	}

	bb_piece = BB_WSILVER;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);

		BBand(bb_buf, w_silver_attacks[from], bb_target);
		if (!BBToU(bb_buf)) {
			continue;
		}

		idirec = (int)adirec[sq_wk][from];
		if (!idirec || !pinned_white_king(ptree, from, idirec)) {
			do {
				to = FirstOne(bb_buf);
				Xor(to, bb_buf);
				cap_piece = BOARD[to] & 0x000F;
				ptree->Move[pmove++] = SET_MOVE(to, from, 0, silver, cap_piece);
				if ((((from % 9) >= 6) && ((from % 9) <= 8)) || (((to % 9) >= 6) && ((to % 9) <= 8))) {
					ptree->Move[pmove++] = SET_MOVE(to, from, 1, silver, cap_piece);
				}
			} while (BBToU(bb_buf));
		}
	}

	bb_piece = BB_WTGOLD;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);

		BBand(bb_buf, w_gold_attacks[from], bb_target);
		if (!BBToU(bb_buf)) {
			continue;
		}
		idirec = (int)adirec[sq_wk][from];
		if (!idirec || !pinned_white_king(ptree, from, idirec)) {
			do {
				to = FirstOne(bb_buf);
				Xor(to, bb_buf);
				cap_piece = BOARD[to] & 0x000F;
				move_piece = BOARD[from] & 0x000F;
				ptree->Move[pmove++] = SET_MOVE(to, from, 0, move_piece, cap_piece);
			} while (BBToU(bb_buf));
		}

	}

	bb_piece = BB_WBISHOP;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);

		bb_buf = bishopAttacks(occ, from);
		BBand(bb_buf, bb_buf, bb_target);
		if (!BBToU(bb_buf)) {
			continue;
		}
		idirec = (int)adirec[sq_wk][from];
		if (!idirec || !pinned_white_king(ptree, from, idirec)) {
			do {
				to = FirstOne(bb_buf);
				Xor(to, bb_buf);

				cap_piece = BOARD[to] & 0x000F;
				ptree->Move[pmove++] = SET_MOVE(to, from, 0, bishop, cap_piece);
				if ((((from % 9) >= 6) && ((from % 9) <= 8)) || (((to % 9) >= 6) && ((to % 9) <= 8))) {
					ptree->Move[pmove++] = SET_MOVE(to, from, 1, bishop, cap_piece);
				}
			} while (BBToU(bb_buf));
		}
	}


	bb_piece = BB_WROOK;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);

		bb_buf = rookAttacks(occ, from);
		BBand(bb_buf, bb_buf, bb_target);
		if (!BBToU(bb_buf)) {
			continue;
		}
		idirec = (int)adirec[sq_wk][from];
		if (!idirec || !pinned_white_king(ptree, from, idirec)) {
			do {
				to = FirstOne(bb_buf);
				Xor(to, bb_buf);

				cap_piece = BOARD[to] & 0x000F;
				ptree->Move[pmove++] = SET_MOVE(to, from, 0, rook, cap_piece);
				if ((((from % 9) >= 6) && ((from % 9) <= 8)) || (((to % 9) >= 6) && ((to % 9) <= 8))) {
					ptree->Move[pmove++] = SET_MOVE(to, from, 1, rook, cap_piece);//	05/23

				}
			} while (BBToU(bb_buf));
		}
	}

	bb_piece = BB_WHORSE;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);

		bb_buf = bishopAttacks(occ, from);
		BBor(bb_buf, bb_buf, king_attacks[from]);
		BBand(bb_buf, bb_buf, bb_target);
		if (!BBToU(bb_buf)) {
			continue;
		}
		idirec = (int)adirec[sq_wk][from];
		if (!idirec || !pinned_white_king(ptree, from, idirec)) {
			do {
				to = FirstOne(bb_buf);
				Xor(to, bb_buf);
				cap_piece = BOARD[to] & 0x000F;
				ptree->Move[pmove++] = SET_MOVE(to, from, 0, horse, cap_piece);
			} while (BBToU(bb_buf));
		}
	}

	bb_piece = BB_WDRAGON;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);

		bb_buf = rookAttacks(occ, from);
		BBor(bb_buf, bb_buf, king_attacks[from]);
		BBand(bb_buf, bb_buf, bb_target);
		if (!BBToU(bb_buf)) {
			continue;
		}
		idirec = (int)adirec[sq_wk][from];
		if (!idirec || !pinned_white_king(ptree, from, idirec)) {
			do {
				to = FirstOne(bb_buf);
				Xor(to, bb_buf);
				cap_piece = BOARD[to] & 0x000F;
				ptree->Move[pmove++] = SET_MOVE(to, from, 0, dragon, cap_piece);
			} while (BBToU(bb_buf));
		}
	}

	// 
	if (!HAND_W) { // Ȃ
		return pmove;
	}
	if (!BBToU(bb_blocker)) { // uꏊȂ
		return pmove;
	}

	bb_target = bb_blocker;
	hand_inf = HAND_W;
	nhand = 0;

	if (IsHandKnight(hand_inf)) {
		type_hand[nhand++] = knight;
	}
	noknight = nhand;
	if (IsHandLance(hand_inf)) {
		type_hand[nhand++] = lance;
	}
	nolance = nhand;
	if (IsHandSilver(hand_inf)) {
		type_hand[nhand++] = silver;
	}
	if (IsHandGold(hand_inf)) {
		type_hand[nhand++] = gold;
	}
	if (IsHandBishop(hand_inf)) {
		type_hand[nhand++] = bishop;
	}
	if (IsHandRook(hand_inf)) {
		type_hand[nhand++] = rook;
	}

	// iQ`FbNj
	if (IsHandPawn(hand_inf)) {

		while (BBToU(bb_blocker)) {
			to = FirstOne(bb_blocker);
			Xor(to, bb_blocker);

			drop_file = to / 9;
			if (drop_file == 0) {
				file_inf = BB_WPAWN.p[0];
			}
			else if (drop_file == 8) {
				file_inf = BB_WPAWN.p[2];
			}
			else {
				file_inf = (BB_WPAWN.p[1] >> ((drop_file - 1) * 9)) & 0x01FF;
			}

			if (BOARD[to] == empty && file_inf <= 0) {
				ptree->Move[pmove++] = SET_MOVE(to, drop_pawn, 0, FU, 0);
			}
		}
	}

	BBand(bb_rank1, bb_target, white_mask_rank1);
	BBand(bb_rank2, bb_target, white_mask_rank2);

	bb_target.p[0] &= 0x7FU;
	bb_target.p[1] &= 0x1FCFE7F3F9FCFE7FU;
	bb_target.p[2] &= 0x7FU;

	while (BBToU(bb_target)) {
		to = FirstOne(bb_target);
		for (int i = 0; i < nhand; i++) {
			ptree->Move[pmove++] = SET_MOVE(to, 80 + type_hand[i], 0, type_hand[i], 0);
		}
		Xor(to, bb_target);
	}
	while (BBToU(bb_rank2)) {
		to = FirstOne(bb_rank2);
		for (int i = noknight; i < nhand; i++) {
			ptree->Move[pmove++] = SET_MOVE(to, 80 + type_hand[i], 0, type_hand[i], 0);
		}
		Xor(to, bb_rank2);
	}
	while (BBToU(bb_rank1)) {
		to = FirstOne(bb_rank1);
		for (int i = nolance; i < nhand; i++) {
			ptree->Move[pmove++] = SET_MOVE(to, 80 + type_hand[i], 0, type_hand[i], 0);
		}
		Xor(to, bb_rank1);
	}

	return pmove;
}