#include <cstdio>
#include <cstdlib>
#include "bitboard.h"
#include "param.h"
#include "shogi.h"

static int ini_bitboards(tree_t *tree);
static void start_posi(tree_t *tree);
static void ini_piece_value(void);
static void ini_dir_table(void);
static void custom_start_bitboard(tree_t *ptree, int koma, int sq);

// JnȌ
void ini_prepare(tree_t  *ptree) {

	// l
	ini_piece_value();

	// magicio[magic bitboardgp邽߂̏
	magic();
}

// p̎
// gValueƁ2xĂ邪A
// ̓rn߂ƂMakeMoveŏɌĂ΂Ă邽߂ł
void hirate(tree_t *ptree) {

	ptree->tesu = 0;

	// ڂɋ̖OĂ(zu)
	for (int i = 0; i < 81; i++) {
		ptree->posi.asquare[i] = init_board[i];
	}

	// zuȂǂbitboard̏
	set_bitboard(ptree);

	// Zô߂̃e[u
	ini_dir_table();
}

void custom(tree_t *ptree) {

	// bitboard(ׂ0)
	ini_bitboards(ptree);

	// wJnǖʂłbitboard
	for (int sq = 0; sq < nsquare; sq++) {
		custom_start_bitboard(ptree, BOARD[sq], sq);
	}

	// zu̗rbg{[h
	ini_attack_tables(ptree);

	// Zô߂̃e[u
	ini_dir_table();
}

// bitboard̏
int set_bitboard(tree_t *tree) {
	int isquare;
	for (isquare = 0; isquare < nsquare; isquare++) {
		abb_mask[isquare] = bb_set_mask(isquare); //ڂ̏ꏊ̃rbgc}XN
	}

	// rbg{[h(ׂ0)
	ini_bitboards(tree);

	// zű̃rbg{[h
	start_posi(tree);

	// zu̗rbg{[h
	ini_attack_tables(tree);

	return 0;
}

static void ini_dir_table(void) {
	int isquare, i, ifile, irank, from, to;
	bitboard_t dir_right[nsquare],		//E8}X
		dir_rdown[nsquare],		//E8}X
		dir_rup[nsquare];		//E8}X
	bitboard_t dir_left[nsquare],		//8}X
		dir_ldown[nsquare],		//8}X
		dir_lup[nsquare];		//8}X
	bitboard_t dir_up[nsquare],			//8}X
		dir_down[nsquare];		//8}X
	bitboard_t bb;

	/* nfile(i̐) = 9, nrank(̐) = 9 */

	for (ifile = 0; ifile < nfile; ifile++) {
		for (irank = 0; irank < nrank; irank++) {
			isquare = ifile * nrank + irank;/* ̐,0`80 */
			BBIni(dir_right[isquare]);
			BBIni(dir_rdown[isquare]);
			BBIni(dir_rup[isquare]);
			BBIni(dir_left[isquare]);
			BBIni(dir_ldown[isquare]);
			BBIni(dir_lup[isquare]);
			BBIni(dir_up[isquare]);
			BBIni(dir_down[isquare]);

			/*
			̎̑S8W(1`8)mۂĂ

			--Ȅꍇ--
			********
			**011111111
			********

			*/

			for (i = 1; i < nrank; i++) {
				//set_attacks(rank,file,adress)
				set_attacks(irank, ifile - i, dir_right + isquare);//E

				set_attacks(irank + i, ifile + i, dir_ldown + isquare);//

				set_attacks(irank + i, ifile, dir_down + isquare);//

				set_attacks(irank + i, ifile - i, dir_rdown + isquare);//E

				set_attacks(irank, ifile + i, dir_left + isquare);//

				set_attacks(irank - i, ifile + i, dir_lup + isquare);//

				set_attacks(irank - i, ifile, dir_up + isquare);//

				set_attacks(irank - i, ifile - i, dir_rup + isquare);//E
			}
		}
	}
	for (isquare = 0; isquare < nsquare; isquare++) {
		BBor(plus_rays[isquare], dir_rup[isquare], dir_right[isquare]);
		BBor(plus_rays[isquare], plus_rays[isquare], dir_rdown[isquare]);
		BBor(plus_rays[isquare], plus_rays[isquare], dir_up[isquare]);
		/*  EAEAEAplus_rays
		*  ŉYJr.ł͏c3Ă邽
		*  ̓}CiX
		*/

		BBor(minus_rays[isquare], dir_down[isquare], dir_lup[isquare]);
		BBor(minus_rays[isquare], minus_rays[isquare], dir_left[isquare]);
		BBor(minus_rays[isquare], minus_rays[isquare], dir_ldown[isquare]);
		/* AAAminus_rays
		*  ŉYJr.ł͏c3Ă邽
		*  ̓vX
		*/
	}

	for (from = 0; from < nsquare; from++) {
		for (to = 0; to < nsquare; to++) {
			adirec[from][to] = (unsigned char)direc_misc;
		}
		BBor(bb, dir_right[from], dir_left[from]);
		while (BBToU(bb)) {
			to = FirstOne(bb);
			adirec[from][to] = (unsigned char)direc_rank;
			Xor(to, bb);
		}
		BBor(bb, dir_ldown[from], dir_rup[from]);
		while (BBToU(bb)) {
			to = FirstOne(bb);
			adirec[from][to] = (unsigned char)direc_diag1;
			Xor(to, bb);
		}
		BBor(bb, dir_up[from], dir_down[from]);
		while (BBToU(bb)) {
			to = FirstOne(bb);
			adirec[from][to] = (unsigned char)direc_file;
			Xor(to, bb);
		}
		BBor(bb, dir_lup[from], dir_rdown[from]);
		while (BBToU(bb)) {
			to = FirstOne(bb);
			adirec[from][to] = (unsigned char)direc_diag2;
			Xor(to, bb);
		}
	}

	for (from = 0; from < nsquare; from++) {
		for (to = 0; to < nsquare; to++) {
			BBIni(obstacle[from][to]);

			if (from - to > 0) {
				switch (adirec[from][to]) {
				case direc_rank: //E
					BBXor(obstacle[from][to], dir_right[to + 9], dir_right[from]);
					break;
				case direc_file: //
					BBXor(obstacle[from][to], dir_up[to + 1], dir_up[from]);
					break;
				case direc_diag1: //E
					BBXor(obstacle[from][to], dir_rup[to + 10], dir_rup[from]);
					break;
				case direc_diag2: //E
					BBXor(obstacle[from][to], dir_rdown[to + 8], dir_rdown[from]);
					break;
				default:
					break;
				}
			}
			else {
				switch (adirec[from][to]) {
				case direc_rank: //
					BBXor(obstacle[from][to], dir_left[to - 9], dir_left[from]);
					break;
				case direc_file: //
					BBXor(obstacle[from][to], dir_down[to - 1], dir_down[from]);
					break;
				case direc_diag1: //
					BBXor(obstacle[from][to], dir_ldown[to - 10], dir_ldown[from]);
					break;
				case direc_diag2: //
					BBXor(obstacle[from][to], dir_lup[to - 8], dir_lup[from]);
					break;
				default:
					break;
				}
			}
		}
	}
}

void ini_attack_tables(tree_t *tree)
{
	int irank, ifile, pcs, i, buf;
	bitboard_t bb;

	/*

	buf:0`8

	slide.posi | 2 | |			1		   | | 0 |
	------------------------------------------------
	nslide	   | 1 | | 55 46 37 28 19 10 1 | | 1 |
	| 1 | | 55 46 37 28 19 10 1 | | 1 |
	| 1 | | 55 46 37 28 19 10 1 | | 1 |
	| 1 | | 55 46 37 28 19 10 1 | | 1 |
	| 1 | | 55 46 37 28 19 10 1 | | 1 |
	| 1 | | 55 46 37 28 19 10 1 | | 1 |
	| 1 | | 55 46 37 28 19 10 1 | | 1 |
	| 1 | | 55 46 37 28 19 10 1 | | 1 |
	| 1 | | 55 46 37 28 19 10 1 | | 1 |
	------------------------------------------------
	buf			 8	    7  6  5  4  3  2 1     0

	*/

	for (i = 0; i < nsquare; i++) {
		buf = i / 9;
		if (buf == 0) {
			slide[i].nslide = 1;
			slide[i].slide_posi = 0;
		}
		else if (buf == 8) {
			slide[i].nslide = 1;
			slide[i].slide_posi = 2;
		}
		else {
			slide[i].nslide = (9 * (buf - 1)) + 1;
			slide[i].slide_posi = 1;
		}

	}

	for (ifile = 0; ifile < nfile; ifile++) {
		for (irank = 0; irank < nrank; irank++) {

			/* ̗ */
			BBIni(bb); //bitboard̏
			set_attacks(irank - 1, ifile + 1, &bb); //΂ߑO
			set_attacks(irank - 1, ifile - 1, &bb); //E΂ߑO
			set_attacks(irank + 1, ifile + 1, &bb); //΂ߌ
			set_attacks(irank + 1, ifile - 1, &bb); //E΂ߌ
			set_attacks(irank - 1, ifile, &bb); //
			b_silver_attacks[ifile * nrank + irank] = bb;

			/* ̗ */
			BBIni(bb);
			set_attacks(irank - 1, ifile + 1, &bb); //΂ߌ
			set_attacks(irank - 1, ifile - 1, &bb); //E΂ߌ
			set_attacks(irank + 1, ifile - 1, &bb); //E΂ߑO
			set_attacks(irank + 1, ifile + 1, &bb); //΂ߑO
			set_attacks(irank + 1, ifile, &bb); //
			w_silver_attacks[ifile * nrank + irank] = bb;

			/* ̗ */
			BBIni(bb);
			set_attacks(irank - 1, ifile + 1, &bb); //΂ߑO
			set_attacks(irank - 1, ifile - 1, &bb); //E΂ߑO
			set_attacks(irank, ifile + 1, &bb); //
			set_attacks(irank, ifile - 1, &bb); //E
			set_attacks(irank - 1, ifile, &bb); //
			set_attacks(irank + 1, ifile, &bb); //
			b_gold_attacks[ifile * nrank + irank] = bb;

			/* ̗ */
			BBIni(bb);
			set_attacks(irank + 1, ifile + 1, &bb); //΂ߑO
			set_attacks(irank + 1, ifile - 1, &bb); //E΂ߑO
			set_attacks(irank, ifile - 1, &bb); //
			set_attacks(irank, ifile + 1, &bb); //E
			set_attacks(irank + 1, ifile, &bb); //
			set_attacks(irank - 1, ifile, &bb); //
			w_gold_attacks[ifile * nrank + irank] = bb;

			/* ̗iSA茓pj */
			BBIni(bb);
			set_attacks(irank - 1, ifile - 1, &bb); //E΂ߑOij
			set_attacks(irank - 1, ifile + 1, &bb); //΂ߑOij
			set_attacks(irank + 1, ifile - 1, &bb); //E΂ߌiOj
			set_attacks(irank + 1, ifile + 1, &bb); //΂ߌiOj
			set_attacks(irank, ifile - 1, &bb); //E
			set_attacks(irank, ifile + 1, &bb); //
			set_attacks(irank - 1, ifile, &bb); //ʁij
			set_attacks(irank + 1, ifile, &bb); //iʁj
			king_attacks[ifile * nrank + irank] = bb;

			/* j̗ */
			BBIni(bb);
			set_attacks(irank - 2, ifile - 1, &bb); //jnE
			set_attacks(irank - 2, ifile + 1, &bb); //jn
			b_knight_attacks[ifile * nrank + irank] = bb;

			/* j̗ */
			BBIni(bb);
			set_attacks(irank + 2, ifile - 1, &bb); //jnE
			set_attacks(irank + 2, ifile + 1, &bb); //jn
			w_knight_attacks[ifile * nrank + irank] = bb;

			for (pcs = 0; pcs < 128; pcs++) { //7bit̃p^[

				/* cׂĂ̗Zo */
				BBIni(bb);
				for (i = -1; irank + i >= 0; i--) { //
					set_attacks(irank + i, ifile, &bb);
					if ((pcs << 1) & (1 << (irank + i))) { break; }
				}
				for (i = 1; irank + i <= 8; i++) { //
					set_attacks(irank + i, ifile, &bb);
					if ((pcs << 1) & (1 << (irank + i))) { break; }
				}
				file_attacks[ifile*nrank + irank][pcs] = bb;

				/* ׂĂ̗Zo */
				BBIni(bb);
				for (i = -1; ifile + i >= 0; i--) {
					set_attacks(irank, ifile + i, &bb);
					if ((pcs << 1) & (1 << (ifile + i))) { break; } //vύX
				}
				for (i = 1; ifile + i <= 8; i++) {
					set_attacks(irank, ifile + i, &bb);
					if ((pcs << 1) & (1 << (ifile + i))) { break; } //vύX
				}
				rank_attacks[ifile*nrank + irank][pcs] = bb;
			}
		}
	}
	black_mask_rank1.p[0] = 0x1U;
	black_mask_rank1.p[1] = 0x40201008040201U;
	black_mask_rank1.p[2] = 0x1U;
	black_mask_rank2.p[0] = 0x2U;
	black_mask_rank2.p[1] = 0x80402010080402U;
	black_mask_rank2.p[2] = 0x2U;

	white_mask_rank1.p[0] = 0x100U;
	white_mask_rank1.p[1] = 0x4020100804020100U;
	white_mask_rank1.p[2] = 0x100U;
	white_mask_rank2.p[0] = 0x80U;
	white_mask_rank2.p[1] = 0x2010080402010080U;
	white_mask_rank2.p[2] = 0x80U;


}

/*  0 <= irank <= 8 && 0 <= ifile <= 8 Ȃ΁A
*  w肳ꂽ}X̃rbgĂ
*/
static void set_attacks(int irank, int ifile, bitboard_t *pbb) {
	if (irank >= rank1 && irank <= rank9 && ifile >= file1
		&& ifile <= file9) {
		Xor(ifile * nrank + irank, *pbb);
	}
}

static int ini_bitboards(tree_t *ptree) {
	BBIni(ptree->posi.b_occupied);
	BBIni(ptree->posi.w_occupied);
	BBIni(ptree->posi.b_pawn);
	BBIni(ptree->posi.w_pawn);
	BBIni(ptree->posi.b_lance);
	BBIni(ptree->posi.w_lance);
	BBIni(ptree->posi.b_knight);
	BBIni(ptree->posi.w_knight);
	BBIni(ptree->posi.b_silver);
	BBIni(ptree->posi.w_silver);
	BBIni(ptree->posi.b_gold);
	BBIni(ptree->posi.w_gold);
	BBIni(ptree->posi.b_tgold);
	BBIni(ptree->posi.w_tgold);
	BBIni(ptree->posi.b_bishop);
	BBIni(ptree->posi.w_bishop);
	BBIni(ptree->posi.b_rook);
	BBIni(ptree->posi.w_rook);
	BBIni(ptree->posi.b_rd);
	BBIni(ptree->posi.w_rd);
	BBIni(ptree->posi.b_bh);
	BBIni(ptree->posi.w_bh);
	BBIni(ptree->posi.b_hdk);
	BBIni(ptree->posi.w_hdk);
	BBIni(ptree->posi.b_pro_pawn);
	BBIni(ptree->posi.w_pro_pawn);
	BBIni(ptree->posi.b_pro_lance);
	BBIni(ptree->posi.w_pro_lance);
	BBIni(ptree->posi.b_pro_knight);
	BBIni(ptree->posi.w_pro_knight);
	BBIni(ptree->posi.b_pro_silver);
	BBIni(ptree->posi.w_pro_silver);
	BBIni(ptree->posi.b_horse);
	BBIni(ptree->posi.w_horse);
	BBIni(ptree->posi.b_dragon);
	BBIni(ptree->posi.w_dragon);
	return 0;
}

static void custom_start_bitboard(tree_t *ptree, int koma, int sq) {

	for (int isquare = 0; isquare < nsquare; isquare++) {
		abb_mask[isquare] = bb_set_mask(isquare); //ڂ̏ꏊ̃rbgc}XN
	}

	switch (koma) {
	case BFU:
		Xor(sq, BB_BPAWN);
		Xor(sq, BB_BOCCUPY);
		break;
	case BKY:
		Xor(sq, BB_BLANCE);
		Xor(sq, BB_BOCCUPY);
		break;
	case BKE:
		Xor(sq, BB_BKNIGHT);
		Xor(sq, BB_BOCCUPY);
		break;
	case BGI:
		Xor(sq, BB_BSILVER);
		Xor(sq, BB_BOCCUPY);
		break;
	case BKI:
		Xor(sq, BB_BGOLD);
		Xor(sq, BB_BTGOLD);
		Xor(sq, BB_BOCCUPY);
		break;
	case BOU:
		//Xor(sq, BB_BKING);
		Xor(sq, BB_B_HDK);
		Xor(sq, BB_BOCCUPY);
		SQ_BKING = (char)sq;
		break;
	case BKA:
		Xor(sq, BB_BBISHOP);
		Xor(sq, BB_B_BH);
		Xor(sq, BB_BOCCUPY);
		break;
	case BHI:
		Xor(sq, BB_BROOK);
		Xor(sq, BB_B_RD);
		Xor(sq, BB_BOCCUPY);
		break;
	case BTO:
		Xor(sq, BB_BPRO_PAWN);
		Xor(sq, BB_BTGOLD);
		Xor(sq, BB_BOCCUPY);
		break;
	case BNY:
		Xor(sq, BB_BPRO_LANCE);
		Xor(sq, BB_BTGOLD);
		Xor(sq, BB_BOCCUPY);
		break;
	case BNK:
		Xor(sq, BB_BPRO_KNIGHT);
		Xor(sq, BB_BTGOLD);
		Xor(sq, BB_BOCCUPY);
		break;
	case BNG:
		Xor(sq, BB_BPRO_SILVER);
		Xor(sq, BB_BTGOLD);
		Xor(sq, BB_BOCCUPY);
		break;
	case BUM:
		Xor(sq, BB_BHORSE);
		Xor(sq, BB_B_BH);
		Xor(sq, BB_B_HDK);
		Xor(sq, BB_BOCCUPY);
		break;
	case BRY:
		Xor(sq, BB_BDRAGON);
		Xor(sq, BB_B_RD);
		Xor(sq, BB_B_HDK);
		Xor(sq, BB_BOCCUPY);
		break;
		//////////////////////////////////////////////////////////////
	case WFU:
		Xor(sq, BB_WPAWN);
		Xor(sq, BB_WOCCUPY);
		break;
	case WKY:
		Xor(sq, BB_WLANCE);
		Xor(sq, BB_WOCCUPY);
		break;
	case WKE:
		Xor(sq, BB_WKNIGHT);
		Xor(sq, BB_WOCCUPY);
		break;
	case WGI:
		Xor(sq, BB_WSILVER);
		Xor(sq, BB_WOCCUPY);
		break;
	case WKI:
		Xor(sq, BB_WGOLD);
		Xor(sq, BB_WTGOLD);
		Xor(sq, BB_WOCCUPY);
		break;
	case WOU:
		//Xor(sq, BB_WKING);
		Xor(sq, BB_W_HDK);
		SQ_WKING = (char)sq;
		Xor(sq, BB_WOCCUPY);
		break;
	case WKA:
		Xor(sq, BB_WBISHOP);
		Xor(sq, BB_W_BH);
		Xor(sq, BB_WOCCUPY);
		break;
	case WHI:
		Xor(sq, BB_WROOK);
		Xor(sq, BB_W_RD);
		Xor(sq, BB_WOCCUPY);
		break;
	case WTO:
		Xor(sq, BB_WPRO_PAWN);
		Xor(sq, BB_WTGOLD);
		Xor(sq, BB_WOCCUPY);
		break;
	case WNY:
		Xor(sq, BB_WPRO_LANCE);
		Xor(sq, BB_WTGOLD);
		Xor(sq, BB_WOCCUPY);
		break;
	case WNK:
		Xor(sq, BB_WPRO_KNIGHT);
		Xor(sq, BB_WTGOLD);
		Xor(sq, BB_WOCCUPY);
		break;
	case WNG:
		Xor(sq, BB_WPRO_SILVER);
		Xor(sq, BB_WTGOLD);
		Xor(sq, BB_WOCCUPY);
		break;
	case WUM:
		Xor(sq, BB_WHORSE);
		Xor(sq, BB_W_BH);
		Xor(sq, BB_W_HDK);
		Xor(sq, BB_WOCCUPY);
		break;
	case WRY:
		Xor(sq, BB_WDRAGON);
		Xor(sq, BB_W_RD);
		Xor(sq, BB_W_HDK);
		Xor(sq, BB_WOCCUPY);
		break;
	default:
		break;
	}
}

static void start_posi(tree_t *ptree) {
	static bitboard_t bb1, bb2, bb3, bb4;

	ptree->posi.w_pawn.p[0] = 0x4;
	ptree->posi.w_pawn.p[1] = 0x100804020100804;
	ptree->posi.w_pawn.p[2] = 0x4;
	ptree->posi.w_lance.p[0] = 0x1;
	ptree->posi.w_lance.p[2] = 0x1;
	ptree->posi.w_knight.p[1] = 0x40000000000001;
	ptree->posi.w_silver.p[1] = 0x200000000200;
	ptree->posi.w_gold.p[1] = 0x1000040000;
	ptree->posi.w_tgold = ptree->posi.w_gold;
	ptree->posi.w_bishop.p[1] = 0x2;
	ptree->posi.w_rook.p[1] = 0x80000000000000;
	ptree->posi.w_hdk.p[1] = 0x8000000;
	ptree->posi.w_bh = ptree->posi.w_bishop;
	ptree->posi.w_rd = ptree->posi.w_rook;

	ptree->posi.b_pawn.p[0] = 0x40;
	ptree->posi.b_pawn.p[1] = 0x1008040201008040;
	ptree->posi.b_pawn.p[2] = 0x40;
	ptree->posi.b_lance.p[0] = 0x100;
	ptree->posi.b_lance.p[2] = 0x100;
	ptree->posi.b_knight.p[1] = 0x4000000000000100;
	ptree->posi.b_silver.p[1] = 0x20000000020000;
	ptree->posi.b_gold.p[1] = 0x100004000000;
	ptree->posi.b_tgold = ptree->posi.b_gold;
	ptree->posi.b_bishop.p[1] = 0x2000000000000000;
	ptree->posi.b_rook.p[1] = 0x80;
	ptree->posi.b_hdk.p[1] = 0x800000000;
	ptree->posi.b_bh = ptree->posi.b_bishop;
	ptree->posi.b_rd = ptree->posi.b_rook;

	BBor(bb1, ptree->posi.b_pawn, ptree->posi.b_lance);
	BBor(bb2, ptree->posi.b_knight, ptree->posi.b_silver);
	BBor(bb3, ptree->posi.b_gold, ptree->posi.b_bishop);
	BBor(bb4, ptree->posi.b_rook, ptree->posi.b_hdk);
	BBor(ptree->posi.b_occupied, bb1, bb2);
	BBor(ptree->posi.b_occupied, ptree->posi.b_occupied, bb3);
	BBor(ptree->posi.b_occupied, ptree->posi.b_occupied, bb4);


	BBor(bb1, ptree->posi.w_pawn, ptree->posi.w_lance);
	BBor(bb2, ptree->posi.w_knight, ptree->posi.w_silver);
	BBor(bb3, ptree->posi.w_gold, ptree->posi.w_bishop);
	BBor(bb4, ptree->posi.w_rook, ptree->posi.w_hdk);
	BBor(ptree->posi.w_occupied, bb1, bb2);
	BBor(ptree->posi.w_occupied, ptree->posi.w_occupied, bb3);
	BBor(ptree->posi.w_occupied, ptree->posi.w_occupied, bb4);

	HAND_B = 0ULL;
	HAND_W = 0ULL;
	TURN = black;
	SQ_WKING = (char)36;
	SQ_BKING = (char)44;
}

static void ini_piece_value(void) 
{
	/*  */
	p_value[15 + pawn] = DPawn;
	p_value[15 + lance] = DLance;
	p_value[15 + knight] = DKnight;
	p_value[15 + silver] = DSilver;
	p_value[15 + gold] = DGold;
	p_value[15 + bishop] = DBishop;
	p_value[15 + rook] = DRook;
	p_value[15 + king] = DKing;
	p_value[15 + pro_pawn] = DProPawn;
	p_value[15 + pro_lance] = DProLance;
	p_value[15 + pro_knight] = DProKnight;
	p_value[15 + pro_silver] = DProSilver;
	p_value[15 + horse] = DHorse;
	p_value[15 + dragon] = DDragon;

	p_value[15 - pawn] = p_value[15 + pawn];
	p_value[15 - lance] = p_value[15 + lance];
	p_value[15 - knight] = p_value[15 + knight];
	p_value[15 - silver] = p_value[15 + silver];
	p_value[15 - gold] = p_value[15 + gold];
	p_value[15 - bishop] = p_value[15 + bishop];
	p_value[15 - rook] = p_value[15 + rook];
	p_value[15 - king] = p_value[15 + king];
	p_value[15 - pro_pawn] = p_value[15 + pro_pawn];
	p_value[15 - pro_lance] = p_value[15 + pro_lance];
	p_value[15 - pro_knight] = p_value[15 + pro_knight];
	p_value[15 - pro_silver] = p_value[15 + pro_silver];
	p_value[15 - horse] = p_value[15 + horse];
	p_value[15 - dragon] = p_value[15 + dragon];
}