#include <cstdio>
#include <cstdlib>

#include "bitboard.h"
#include "shogi.h"
#include "magic_number.h"

//debugp
#define TRANSFORM_CHECK

int count_1s(uint64 bit);
int pop_1st_bit(uint64 *bb);
uint64 index_to_uint64(int index, int bits, uint64 m);
int transform(uint64 b, uint64 magic, int bits);
int transform2(uint64 b, uint64 a, uint64 magic1, uint64 magic2, int bits);
uint64 find_magic(int sq, int m, int bishop);
uint64 find_magic2(int sq, int m);
uint64 find_magic3(int sq, int m);
void find_magic4(int sq, int m);
void createRookAttackXLine(int sq, uint64 blockPattern, bitboard_t* result);
void createRookAttackYLine(int sq, uint64 blockPattern, bitboard_t* result);

//Ăbit𐔂Ă
int count_1s(uint64 b) {
	int r;
	for (r = 0; b; r++, b &= b - 1);
	return r;
}


//ԉE[bit̏ꏊoĂ
int pop_1st_bit(uint64 *bb) {
	uint64 b = *bb ^ (*bb - 1);
	unsigned int fold = (unsigned)((b & 0xffffffff) ^ (b >> 32));
	*bb &= (*bb - 1);//ԉE[Ă
	return BitTable[(fold * 0x783a9b23) >> 26];
}


//index?  bit  mask
uint64 index_to_uint64(int index, int bits, uint64 m) {
	int i, j;
	uint64 result = 0ULL;
	for (i = 0; i < bits; i++) {
		j = pop_1st_bit(&m);//mask̈ԉE[rbg̏ꏊAĂт邽щE[bitĂ
		if (index & (1 << i)) result |= (1ULL << j);
	}
	return result;
}


//magic number痘Zozindex(int)
//@param::b bitboard
//@param::magic Magic Number
//@param::bits shift
int transform(uint64 b, uint64 magic, int bits) {

	//vZCDԂP
#if defined(TRANSFORM_CHECK)
	return
		(unsigned)((int)b*(int)magic ^ (int)(b >> 32)*(int)(magic >> 32)) >> (32 - bits);
#else
	return
		(unsigned int)((b * magic) >> (64 - bits));

#endif
}


//magic number痘Zozindex(int) [1,9ؗp]
int transform2(uint64 b, uint64 a, uint64 magic1, uint64 magic2, int bits) {
#if defined(TRANSFORM_CHECK)
	return
		((unsigned)((int)b*(int)magic1 ^ (int)(b >> 32)*(int)(magic1 >> 32)) ^ (unsigned)((int)a*(int)magic2 ^ (int)(a >> 32)*(int)(magic2 >> 32))) >> (32 - bits);
#else
	return
		(int)(((b * magic1) ^ (a *magic2)) >> (64 - bits));

#endif
}

int transform3(uint64 b, uint64 a, uint64 magic1, uint64 magic2, int bits) {
	return (int)(((b * magic1) ^ (a * magic2)) >> (64 - bits));
}


//Zoz̐
//msqɑ΂ẴVtg񐔁i2~8ؗpj
uint64 find_magic(int sq, int m, int bishop) {
	static uint64 mask, b[16384], magic;
	static bitboard_t  a[16384], used[16384];
	static int n, i, j, k, fail;

	mask = bishop ? bmask(sq) : rmask(sq);//̏ꏊɑ΂ă}XN
	if (bishop) {
		mBishoptbl[sq + 9].mask.p[1] = mask;
		mBishoptbl[sq + 9].mask.p[0] = 0ULL;
		mBishoptbl[sq + 9].mask.p[2] = 0ULL;
		mBishoptbl[sq + 9].shift = m;
	}
	else {
		mRooktbl[sq + 9].mask.p[1] = mask;
		mRooktbl[sq + 9].mask.p[0] = 0ULL;
		mRooktbl[sq + 9].mask.p[2] = 0ULL;
		mRooktbl[sq + 9].shift = m;
	}
	n = count_1s(mask);//1邩
	for (i = 0; i < (1 << n); i++) {
		b[i] = index_to_uint64(i, n, mask);//͈̔͂ł肤bit
		bishop ? batt(sq, b[i], &a[i]) : ratt(sq, b[i], &a[i]);//ɉۂ̗
	}
	for (i = 0;i < 16384;i++) {
		if (bishop) {
			bishop_attacks[sq + 9][i].p[0] = 0ULL;
			bishop_attacks[sq + 9][i].p[1] = 0ULL;
			bishop_attacks[sq + 9][i].p[2] = 0ULL;
		}
		else {
			rook_attacks[sq + 9][i].p[0] = 0ULL;
			rook_attacks[sq + 9][i].p[1] = 0ULL;
			rook_attacks[sq + 9][i].p[2] = 0ULL;
		}
	}
	if (bishop) {
		mBishoptbl[sq + 9].magic[0] = BMagic[sq + 9];
		for (i = 0;i < (1 << n); i++) {
			j = transform(b[i], mBishoptbl[sq + 9].magic[0], m);
			bishop_attacks[sq + 9][j] = a[i];
			if (sq + 9 == 10) {
				int c;
				c = 0;
			}
		}
	}
	else {
		mRooktbl[sq + 9].magic[0] = RMagic[sq + 9];
		for (i = 0;i < (1 << n); i++) {
			j = transform(b[i], mRooktbl[sq + 9].magic[0], m);
			rook_attacks[sq + 9][j] = a[i];
		}
	}
	return 0ULL;
}

/* 1,9ؗp̔Ԃ̌Zoz̐
initpH
*/
uint64 find_magic2(int sq, int m) {

	static uint64 mask1, mask2, b[16384], a[16384], magic1, magic2;
	int i, i2, n1, n2, xor;
	static bitboard_t c[128][128], used[16384];

	mask1 = sidermask(sq);//̏ꏊɑ΂ă}XN()
	mask2 = sidemask(sq);//TCh
	if (sq < 9) {
		mRooktbl[sq].mask.p[0] = mask2;
		mRooktbl[sq].mask.p[2] = 0ULL;
	}
	else {
		mRooktbl[sq].mask.p[2] = mask2;
		mRooktbl[sq].mask.p[0] = 0ULL;
	}
	mRooktbl[sq].mask.p[1] = mask1;
	mRooktbl[sq].shift = (7 + m);

	//1邩
	n1 = count_1s(mask1); //
	n2 = count_1s(mask2); //c

	for (i = 0; i < (1 << n1); i++) {
		b[i] = index_to_uint64(i, n1, mask1);//
	}
	for (i = 0; i < (1 << n2); i++) {
		a[i] = index_to_uint64(i, n2, mask2);//c::[
	}

	for (i = 0;i < (1 << n1); i++) {
		for (i2 = 0;i2 < (1 << n2);i2++) {
			ratt3(sq, b[i], &c[i][i2]);
			if (sq < 9) {
				c[i][i2].p[0] |= ratt2(sq, a[i2]);//ۂ̗
			}
			else {
				c[i][i2].p[2] |= ratt2(sq, a[i2]);
			}
		}
	}

	//init
	for (i = 0; i < 16384; i++) {
		rook_attacks[sq][i].p[0] = 0ULL;
		rook_attacks[sq][i].p[1] = 0ULL;
		rook_attacks[sq][i].p[2] = 0ULL;
	}


	mRooktbl[sq].magic[0] = RMagic[sq];//
	if (sq < 9) {
		mRooktbl[sq].magic[1] = SideMagic_Right[sq];
	}
	else {
		mRooktbl[sq].magic[1] = SideMagic_Left[sq % 9];//TCh
	}

	//Xg̐
	for (i = 0;i < (1 << n1); i++) {
		for (i2 = 0;i2 < (1 << n2); i2++) {
			xor = transform2(b[i], a[i2], mRooktbl[sq].magic[0], mRooktbl[sq].magic[1], 7 + m);
			rook_attacks[sq][xor] = c[i][i2];
		}
	}

	return 0ULL;
}


//pp̗Zoz̐i1,9؁j
uint64 find_magic3(int sq, int m) {//msqɑ΂ẴVtg
	uint64 mask, b[16384];
	bitboard_t a[16384];
	int i, j, n;
	mask = sidebmask(sq);//̏ꏊɑ΂ă}XN
	mBishoptbl[sq].mask.p[1] = mask;
	mBishoptbl[sq].mask.p[0] = 0ULL;
	mBishoptbl[sq].mask.p[2] = 0ULL;
	mBishoptbl[sq].shift = m;
	n = count_1s(mask);//1邩

	for (i = 0; i < (1 << n); i++) {
		b[i] = index_to_uint64(i, n, mask);//͈̔͂ł肤bit 
		batt2(sq, b[i], &a[i]);//ɉۂ̗	
	}
	for (i = 0; i < 16384; i++) {
		bishop_attacks[sq][i].p[0] = 0ULL;
		bishop_attacks[sq][i].p[1] = 0ULL;
		bishop_attacks[sq][i].p[2] = 0ULL;
	}
	mBishoptbl[sq].magic[0] = BMagic[sq];
	for (i = 0;i < (1 << n);i++) {
		j = transform(b[i], mBishoptbl[sq].magic[0], m);
		bishop_attacks[sq][j] = a[i];
	}
	return 0ULL;
}


///////////////////////////////////////////////////////////////////////
//2 ~ 8؂ɂԂ̗cꂼ΂炵ċ߂@
///////////////////////////////////////////////////////////////////////
void find_magic4(int sq, int m) {
	static uint64      magicNumberX;
	static uint64      magicNumberY;
	static uint64      xLineBlockPattern[128];     //Ԃ̉̃ubNp^[ ő128p^[
	static uint64      yLineBlockPattern[128];     //Ԃ̏c̃ubNp^[ ő128p^[
	static bitboard_t  attack[128][128];	       //Ԃ̗p^[
	static bitboard_t used[16384];
	unsigned           index;
	//Ԃɑ΂\bit𒊏o邽߂̃}XN
	uint64 crossMask = rmask(sq);
	uint64 yLineMask = crossMask & ((uint64)0x0fe << ((sq / 9) * 9));
	uint64 xLineMask = crossMask ^ yLineMask;

	int xBitNum = count_1s(xLineMask);//rbg݂邩
	int yBitNum = count_1s(yLineMask);

	//ꂼ̃}XNۑĂ
	mNewRooktbl[sq + 9].mask.p[0] = xLineMask;
	mNewRooktbl[sq + 9].mask.p[1] = yLineMask;
	mNewRooktbl[sq + 9].shift = xBitNum + yBitNum;
	mNewRooktbl[sq + 9].magic[0] = rookMagicNumber[sq][0];
	mNewRooktbl[sq + 9].magic[1] = rookMagicNumber[sq][1];

	for (int i = 0; i < 16384; i++) {
		new_rook_attacks[sq + 9][i].p[0] = 0ULL;
		new_rook_attacks[sq + 9][i].p[1] = 0ULL;
		new_rook_attacks[sq + 9][i].p[2] = 0ULL;
	}

	//x̃ubNp^[ԗ
	for (int xPattern = 0; xPattern < (1 << xBitNum); xPattern++) {

		//X̃ubNp^[rbg{[hp[1]ɕϊ
		xLineBlockPattern[xPattern] = index_to_uint64(xPattern, xBitNum, xLineMask);

		//ỹubNp^[ԗ
		for (int yPattern = 0; yPattern < (1 << yBitNum); yPattern++) {

			//ỸubNp^[rbg{[hp[1]ɕϊ
			yLineBlockPattern[yPattern] = index_to_uint64(yPattern, yBitNum, yLineMask);

			bitboard_t x_attack;
			bitboard_t y_attack;

			createRookAttackXLine(sq, xLineBlockPattern[xPattern], &x_attack);
			createRookAttackYLine(sq, yLineBlockPattern[yPattern], &y_attack);

			attack[xPattern][yPattern].p[0] = x_attack.p[0] | y_attack.p[0];
			attack[xPattern][yPattern].p[1] = x_attack.p[1] | y_attack.p[1];
			attack[xPattern][yPattern].p[2] = x_attack.p[2] | y_attack.p[2];

		}//Yp^[

	}//Xp^[

	 //
	for (int i = 0; i < 16384; i++) {
		new_rook_attacks[sq + 9][i].p[0] = 0ULL;
		new_rook_attacks[sq + 9][i].p[1] = 0ULL;
		new_rook_attacks[sq + 9][i].p[2] = 0ULL;
	}

	for (int xPattern = 0; xPattern < (1 << xBitNum); xPattern++) {

		for (int yPattern = 0; yPattern < (1 << yBitNum); yPattern++) {

			//}WbNio -> CfNX𐶐
			index = transform3(xLineBlockPattern[xPattern],
				yLineBlockPattern[yPattern],
				mNewRooktbl[sq + 9].magic[0],
				mNewRooktbl[sq + 9].magic[1],
				xBitNum + yBitNum
				);

			new_rook_attacks[sq + 9][index] = attack[xPattern][yPattern];

		}//for(Yp^[)

	}//for(Xp^[

}

////////////////////////////////////////////////////////////////////////////
//2 ~ 8؂ɂԂ̉̊S߂
////////////////////////////////////////////////////////////////////////////
void createRookAttackXLine(int sq, uint64 blockPattern, bitboard_t* result) {

	int xPos = sq / 9;
	int yPos = sq % 9;

	result->p[0] = 0ULL;
	result->p[1] = 0ULL;
	result->p[2] = 0ULL;

	//̗߂
	for (int x = xPos + 1; x <= 7; x++) {

		//9
		if (x == 7)
			result->p[2] |= 1ULL << yPos;

		//2 ~ 8
		else {
			result->p[1] |= 1ULL << (x * 9 + yPos);
			if (blockPattern & (1ULL << (x * 9 + yPos)))
				break;

		}

	}

	//E̗߂
	for (int x = xPos - 1; x >= -1; x--) {

		//1
		if (x == -1)
			result->p[0] |= 1ULL << yPos;

		else {
			result->p[1] |= 1ULL << (x * 9 + yPos);
			if (blockPattern & (1ULL << (x * 9 + yPos)))
				break;
		}

	}

}

////////////////////////////////////////////////////////////////////////////
//2 ~ 8؂ɂԂ̏c̊S߂
////////////////////////////////////////////////////////////////////////////
void createRookAttackYLine(int sq, uint64 blockPattern, bitboard_t* result) {

	int xPos = sq / 9;
	int yPos = sq % 9;

	result->p[0] = 0ULL;
	result->p[1] = 0ULL;
	result->p[2] = 0ULL;

	//̗߂
	for (int y = yPos + 1; y <= 8; y++) {

		uint64  targetPos = 1ULL << (xPos * 9 + y);

		//tO𗧂Ă
		result->p[1] |= targetPos;

		//ubN݂Ă炻ւ͐i߂Ȃ
		if (blockPattern & targetPos)
			break;

	}

	//̗߂
	for (int y = yPos - 1; y >= 0; y--) {

		uint64  targetPos = 1ULL << (xPos * 9 + y);

		//tO𗧂Ă
		result->p[1] |= targetPos;

		//ubN݂Ă炻ւ͐i߂Ȃ
		if (blockPattern & targetPos)
			break;

	}

}

int magic(void) {
	int square;
	// 
	for (square = 0; square < 81; square++) {
		if (square < 9) find_magic2(square, sideRBit[square]);
		else if (square < 72) {
			find_magic(square - 9, RBits[square - 9], 0);
			find_magic4(square - 9, RBits[square - 9]);
		}
		else  find_magic2(square, sideRBit[square % 9]);
	}

	// 1, 9؂̔ԏRs[
	for (int square = 0; square < 81; square++) {
		if (9 <= square && square < 72)
			continue;

		mNewRooktbl[square].magic[0] = mRooktbl[square].magic[0];
		mNewRooktbl[square].magic[1] = mRooktbl[square].magic[1];
		mNewRooktbl[square].mask = mRooktbl[square].mask;
		mNewRooktbl[square].shift = mRooktbl[square].shift;

		for (int pattern = 0; pattern < 16384; pattern++) {
			new_rook_attacks[square][pattern] = rook_attacks[square][pattern];
		}
	}

	// p
	for (square = 0; square < 81; square++) {
		if (square < 9) find_magic3(square, sideBBit[square]);
		else if (square < 72) find_magic(square - 9, BBits[square - 9], 1);
		else find_magic3(square, sideBBit[square % 9]);
	}

	return 0;
}