#include "bitboard.h"
#include "usi.h"
#include "shogi.h"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//łs
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
#define DropB(PIECE, piece, itemp)												 \
	Xor(to, BB_B ## PIECE);														 \
	HAND_B -=  flag_hand_ ## piece;												 \
	BOARD[to] = piece;                                                     

#define DropW(PIECE, piece, itemp)												 \
	Xor(to, BB_W ## PIECE);														 \
	HAND_W -=  flag_hand_ ## piece;												 \
	BOARD[to] = piece + enemy;                                               

///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//̋Ƃړs
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
#define CapB(PIECE, piece, pro_piece)           \
	Xor(to , BB_B ## PIECE);                    \
	HAND_W  += flag_hand_ ## piece;

#define CapW(PIECE, piece, pro_piece)           \
	Xor(to, BB_W ##  PIECE);                    \
	HAND_B  += flag_hand_ ## piece;             

///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//ړs
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
#define NoCapProB(PIECE, PRO_PIECE, piece, pro_piece)                          \
	Xor(from, BB_B ## PIECE);                                                  \
	Xor(to, BB_B ## PRO_PIECE);                                                \
	BOARD[to] = pro_piece;                                                  

#define NoCapProW(PIECE, PRO_PIECE, piece, pro_piece)                          \
	Xor(from, BB_W ## PIECE);                                                  \
	Xor(to, BB_W ## PRO_PIECE);                                                \
	BOARD[to] = pro_piece + enemy;                                          

///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//ʏړs
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
#define NoCapNoProB(PIECE, piece)                                          \
	SetClear(BB_B ## PIECE);                                               \
	BOARD[to] = piece;                                                 

//肪ʏړs
#define NoCapNoProW(PIECE, piece)                                          \
	SetClear(BB_W ## PIECE);                                               \
	BOARD[to] = piece + enemy;                                         

#define HASH_CHECK

void CONV make_move_b(tree_t *ptree, unsigned int move) {

	const int from = (int)GetMoveFrom(move);
	const int to = (int)GetMoveTo(move);
	int itemp = 0;

	// ł
	if (from >= nsquare) {

		switch (DropPiece(from)) {
#ifdef HASH_CHECK
		case pawn:
			itemp = (int)I2HandPawn(HAND_B);
			DropB(PAWN, pawn, itemp);
			break;
		case lance:
			itemp = (int)I2HandLance(HAND_B);
			DropB(LANCE, lance, itemp);
			break;
		case knight:
			itemp = (int)I2HandKnight(HAND_B);
			DropB(KNIGHT, knight, itemp);
			break;
		case silver:
			itemp = (int)I2HandSilver(HAND_B);
			DropB(SILVER, silver, itemp);
			break;
		case gold:
			itemp = (int)I2HandGold(HAND_B);
			DropB(GOLD, gold, itemp);
			Xor(to, BB_BTGOLD);
			break;
		case bishop:
			itemp = (int)I2HandBishop(HAND_B);
			DropB(BISHOP, bishop, itemp);
			Xor(to, BB_B_BH);
			break;
		case rook:
			itemp = (int)I2HandRook(HAND_B);
			DropB(ROOK, rook, itemp);
			Xor(to, BB_B_RD);
			break;
		default:
			break;
#else
		case pawn:   DropB(PAWN, pawn);  break;
		case lance:  DropB(LANCE, lance);  break;
		case knight: DropB(KNIGHT, knight);  break;
		case silver: DropB(SILVER, silver);  break;
		case gold:   DropB(GOLD, gold);
			Xor(to, BB_BTGOLD);     break;
		case bishop: DropB(BISHOP, bishop);
			Xor(to, BB_B_BH);       break;
		case rook:   DropB(ROOK, rook);
			Xor(to, BB_B_RD);       break;
#endif
		}
		Xor(to, BB_BOCCUPY);
	}

	// Ֆʏ̋
	else {
		// move_piece : Acap_piece : Apromote : 萬炸
		const int move_piece = (int)GetMovePiece(move);
		const int cap_piece = (int)GetMoveCapPiece(move);
		const int promote = (int)GetMovePromoted(move);
		bitboard_t bb_set_clear;

		BBor(bb_set_clear, abb_mask[from], abb_mask[to]); // ړƈړ悾PɂȂĂBB
		SetClear(BB_BOCCUPY); // ړAړ擯XorĂ(clearĂ)Dł͐OCCύXĂ
		BOARD[from] = EMP; // from̈ʒuɂĂ

		// 
		if (promote) {

			switch (move_piece) {
			case pawn:
				Xor(to, BB_BTGOLD);
				NoCapProB(PAWN, PRO_PAWN, pawn, pro_pawn);
				break;
			case lance:
				Xor(to, BB_BTGOLD);
				NoCapProB(LANCE, PRO_LANCE, lance, pro_lance);
				break;
			case knight:
				Xor(to, BB_BTGOLD);
				NoCapProB(KNIGHT, PRO_KNIGHT, knight, pro_knight);
				break;
			case silver:
				Xor(to, BB_BTGOLD);
				NoCapProB(SILVER, PRO_SILVER, silver, pro_silver);
				break;
			case bishop:
				Xor(to, BB_B_HDK);
				SetClear(BB_B_BH);
				NoCapProB(BISHOP, HORSE, bishop, horse);
				break;
			case rook:
				Xor(to, BB_B_HDK);
				SetClear(BB_B_RD);
				NoCapProB(ROOK, DRAGON, rook, dragon);
				break;
			default:
				break;
			}
		}
		// 炸
		else {

			switch (move_piece) {
			case pawn:
				NoCapNoProB(PAWN, pawn);
				break;
			case lance:
				NoCapNoProB(LANCE, lance);
				break;
			case knight:
				NoCapNoProB(KNIGHT, knight);
				break;
			case silver:
				NoCapNoProB(SILVER, silver);
				break;
			case gold:
				NoCapNoProB(GOLD, gold);
				SetClear(BB_BTGOLD);
				break;
			case bishop:
				NoCapNoProB(BISHOP, bishop);
				SetClear(BB_B_BH);
				break;
			case rook:
				NoCapNoProB(ROOK, rook);
				SetClear(BB_B_RD);
				break;
			case king:
				BOARD[to] = king;
				SQ_BKING = (char)to;
				SetClear(BB_B_HDK);
				break;
			case pro_pawn:
				NoCapNoProB(PRO_PAWN, pro_pawn);
				SetClear(BB_BTGOLD);
				break;
			case pro_lance:
				NoCapNoProB(PRO_LANCE, pro_lance);
				SetClear(BB_BTGOLD);
				break;
			case pro_knight:
				NoCapNoProB(PRO_KNIGHT, pro_knight);
				SetClear(BB_BTGOLD);
				break;
			case pro_silver:
				NoCapNoProB(PRO_SILVER, pro_silver);
				SetClear(BB_BTGOLD);
				break;
			case horse:
				NoCapNoProB(HORSE, horse);
				SetClear(BB_B_HDK);
				SetClear(BB_B_BH);
				break;
			case dragon:
				NoCapNoProB(DRAGON, dragon);
				SetClear(BB_B_HDK);
				SetClear(BB_B_RD);
				break;
			default:
				break;
			}
		}

		// 
		if (cap_piece) {
			int hand_piece_num;

			switch (cap_piece) {
			case pawn:
				hand_piece_num = I2HandPawn(ptree->posi.hand_black);
				CapW(PAWN, pawn, pawn);
				break;
			case lance:
				hand_piece_num = I2HandLance(ptree->posi.hand_black);
				CapW(LANCE, lance, lance);
				break;
			case knight:
				hand_piece_num = I2HandKnight(ptree->posi.hand_black);
				CapW(KNIGHT, knight, knight);
				break;
			case silver:
				hand_piece_num = I2HandSilver(ptree->posi.hand_black);
				CapW(SILVER, silver, silver);
				break;
			case gold:
				hand_piece_num = I2HandGold(ptree->posi.hand_black);
				CapW(GOLD, gold, gold);
				Xor(to, BB_WTGOLD);
				break;
			case bishop:
				hand_piece_num = I2HandBishop(ptree->posi.hand_black);
				CapW(BISHOP, bishop, bishop);
				Xor(to, BB_W_BH);
				break;
			case rook:
				hand_piece_num = I2HandRook(ptree->posi.hand_black);
				CapW(ROOK, rook, rook);
				Xor(to, BB_W_RD);
				break;
			case pro_pawn:
				hand_piece_num = I2HandPawn(ptree->posi.hand_black);
				CapW(PRO_PAWN, pawn, pro_pawn);
				Xor(to, BB_WTGOLD);
				break;
			case pro_lance:
				hand_piece_num = I2HandLance(ptree->posi.hand_black);
				CapW(PRO_LANCE, lance, pro_lance);
				Xor(to, BB_WTGOLD);
				break;
			case pro_knight:
				hand_piece_num = I2HandKnight(ptree->posi.hand_black);
				CapW(PRO_KNIGHT, knight, pro_knight);
				Xor(to, BB_WTGOLD);
				break;
			case pro_silver:
				hand_piece_num = I2HandSilver(ptree->posi.hand_black);
				CapW(PRO_SILVER, silver, pro_silver);
				Xor(to, BB_WTGOLD);
				break;
			case horse:
				hand_piece_num = I2HandBishop(ptree->posi.hand_black);
				CapW(HORSE, bishop, horse);
				Xor(to, BB_W_HDK);
				Xor(to, BB_W_BH);
				break;
			case dragon:
				hand_piece_num = I2HandRook(ptree->posi.hand_black);
				CapW(DRAGON, rook, dragon);
				Xor(to, BB_W_HDK);
				Xor(to, BB_W_RD);
				break;
			default:
				break;
			}
			Xor(to, BB_WOCCUPY);
		}
	}
}

void CONV make_move_w(tree_t *ptree, unsigned int move) {

	const int from = (int)GetMoveFrom(move);
	const int to = (int)GetMoveTo(move);
	int itemp = 0;

	// ł
	if (from >= nsquare) {

		switch (DropPiece(from)) {

#ifdef HASH_CHECK
		case pawn:
			itemp = (int)I2HandPawn(HAND_W);
			DropW(PAWN, pawn, itemp);
			break;
		case lance:
			itemp = (int)I2HandLance(HAND_W);
			DropW(LANCE, lance, itemp);
			break;
		case knight:
			itemp = (int)I2HandKnight(HAND_W);
			DropW(KNIGHT, knight, itemp);
			break;
		case silver:
			itemp = (int)I2HandSilver(HAND_W);
			DropW(SILVER, silver, itemp);
			break;
		case gold:
			itemp = (int)I2HandGold(HAND_W);
			DropW(GOLD, gold, itemp);
			Xor(to, BB_WTGOLD);
			break;
		case bishop:
			itemp = (int)I2HandBishop(HAND_W);
			DropW(BISHOP, bishop, itemp);
			Xor(to, BB_W_BH);
			break;
		case rook:
			itemp = (int)I2HandRook(HAND_W);
			DropW(ROOK, rook, itemp);
			Xor(to, BB_W_RD);
			break;
		default:
			break;
#else
		case pawn:   DropW(PAWN, pawn);    break;
		case lance:  DropW(LANCE, lance);   break;
		case knight: DropW(KNIGHT, knight);  break;
		case silver: DropW(SILVER, silver);  break;
		case gold:   DropW(GOLD, gold);
			Xor(to, BB_WTGOLD);     break;
		case bishop: DropW(BISHOP, bishop);
			Xor(to, BB_W_BH);       break;
		case rook:   DropW(ROOK, rook);
			Xor(to, BB_W_RD);       break;
#endif
		}

		Xor(to, BB_WOCCUPY);
	}

	// Ֆʏ̋
	else {
		const int move_piece = (int)GetMovePiece(move);
		const int cap_piece = (int)GetMoveCapPiece(move);
		const int promote = (int)GetMovePromoted(move);
		bitboard_t bb_set_clear;

		BBor(bb_set_clear, abb_mask[from], abb_mask[to]); // ړƈړ悾PɂȂĂ
		SetClear(BB_WOCCUPY); // ړAړ擯XorĂ
		BOARD[from] = EMP;

		// 
		if (promote) {

			switch (move_piece) {
			case pawn:
				Xor(to, BB_WTGOLD);
				NoCapProW(PAWN, PRO_PAWN, pawn, pro_pawn);
				break;
			case lance:
				Xor(to, BB_WTGOLD);
				NoCapProW(LANCE, PRO_LANCE, lance, pro_lance);
				break;
			case knight:
				Xor(to, BB_WTGOLD);
				NoCapProW(KNIGHT, PRO_KNIGHT, knight, pro_knight);
				break;
			case silver:
				Xor(to, BB_WTGOLD);
				NoCapProW(SILVER, PRO_SILVER, silver, pro_silver);
				break;
			case bishop:
				Xor(to, BB_W_HDK);
				SetClear(BB_W_BH);
				NoCapProW(BISHOP, HORSE, bishop, horse);
				break;
			case rook:
				Xor(to, BB_W_HDK);
				SetClear(BB_W_RD);
				NoCapProW(ROOK, DRAGON, rook, dragon);
				break;
			default:
				break;
			}
		}

		// 炸
		else {

			switch (move_piece) {
			case pawn:
				NoCapNoProW(PAWN, pawn);
				break;
			case lance:
				NoCapNoProW(LANCE, lance);
				break;
			case knight:
				NoCapNoProW(KNIGHT, knight);
				break;
			case silver:
				NoCapNoProW(SILVER, silver);
				break;
			case gold:
				NoCapNoProW(GOLD, gold);
				SetClear(BB_WTGOLD);
				break;
			case bishop:
				NoCapNoProW(BISHOP, bishop);
				SetClear(BB_W_BH);
				break;
			case rook:
				NoCapNoProW(ROOK, rook);
				SetClear(BB_W_RD);
				break;
			case king:
				BOARD[to] = king + enemy;
				SQ_WKING = (char)to;
				SetClear(BB_W_HDK);
				break;
			case pro_pawn:
				NoCapNoProW(PRO_PAWN, pro_pawn);
				SetClear(BB_WTGOLD);
				break;
			case pro_lance:
				NoCapNoProW(PRO_LANCE, pro_lance);
				SetClear(BB_WTGOLD);
				break;
			case pro_knight:
				NoCapNoProW(PRO_KNIGHT, pro_knight);
				SetClear(BB_WTGOLD);
				break;
			case pro_silver:
				NoCapNoProW(PRO_SILVER, pro_silver);
				SetClear(BB_WTGOLD);
				break;
			case horse:
				NoCapNoProW(HORSE, horse);
				SetClear(BB_W_HDK);
				SetClear(BB_W_BH);
				break;
			case dragon:
				NoCapNoProW(DRAGON, dragon);
				SetClear(BB_W_HDK);
				SetClear(BB_W_RD);
				break;
			default:
				break;
			}

		}

		// 
		if (cap_piece) {

			int hand_piece_num;

			switch (cap_piece) {
			case pawn:
				hand_piece_num = I2HandPawn(ptree->posi.hand_white);
				CapB(PAWN, pawn, pawn);
				break;
			case lance:
				hand_piece_num = I2HandLance(ptree->posi.hand_white);
				CapB(LANCE, lance, lance);
				break;
			case knight:
				hand_piece_num = I2HandKnight(ptree->posi.hand_white);
				CapB(KNIGHT, knight, knight);
				break;
			case silver:
				hand_piece_num = I2HandSilver(ptree->posi.hand_white);
				CapB(SILVER, silver, silver);
				break;
			case gold:
				hand_piece_num = I2HandGold(ptree->posi.hand_white);
				CapB(GOLD, gold, gold);
				Xor(to, BB_BTGOLD);
				break;
			case bishop:
				hand_piece_num = I2HandBishop(ptree->posi.hand_white);
				CapB(BISHOP, bishop, bishop);
				Xor(to, BB_B_BH);
				break;
			case rook:
				hand_piece_num = I2HandRook(ptree->posi.hand_white);
				CapB(ROOK, rook, rook);
				Xor(to, BB_B_RD);
				break;
			case pro_pawn:
				hand_piece_num = I2HandPawn(ptree->posi.hand_white);
				CapB(PRO_PAWN, pawn, pro_pawn);
				Xor(to, BB_BTGOLD);
				break;
			case pro_lance:
				hand_piece_num = I2HandLance(ptree->posi.hand_white);
				CapB(PRO_LANCE, lance, pro_lance);
				Xor(to, BB_BTGOLD);
				break;
			case pro_knight:
				hand_piece_num = I2HandKnight(ptree->posi.hand_white);
				CapB(PRO_KNIGHT, knight, pro_knight);
				Xor(to, BB_BTGOLD);
				break;
			case pro_silver:
				hand_piece_num = I2HandSilver(ptree->posi.hand_white);
				CapB(PRO_SILVER, silver, pro_silver);
				Xor(to, BB_BTGOLD);
				break;
			case horse:
				hand_piece_num = I2HandBishop(ptree->posi.hand_white);
				CapB(HORSE, bishop, horse);
				Xor(to, BB_B_HDK);
				Xor(to, BB_B_BH);
				break;
			case dragon:
				hand_piece_num = I2HandRook(ptree->posi.hand_white);
				CapB(DRAGON, rook, dragon);
				Xor(to, BB_B_HDK);
				Xor(to, BB_B_RD);
				break;
			default:
				break;
			}

			Xor(to, BB_BOCCUPY);
		}
	}
}