#include <cstdio>

#include "shogi.h"
#include "bitboard.h"

int black_drop(tree_t *ptree, int pmove) {
	bitboard_t occ, bb_drop, bb_rank2, bb_rank1, pawn_posi;
	uint64 file_inf;
	int i, to, file, rank, flag;
	int nhand, nolance, noknight;
	int type_hand[6];
	unsigned int hand_inf;

	if (!HAND_B) { // 莝Ȃ
		return pmove;
	}

	BBor(occ, ptree->posi.b_occupied, ptree->posi.w_occupied); // Ֆʏŋꏊ
	BBNot(bb_drop, occ); // Ֆʏŋ̂Ȃꏊ

	hand_inf = HAND_B;
	nhand = 0;

	// j
	if (IsHandKnight(hand_inf)) {
		type_hand[nhand++] = knight;
	}
	noknight = nhand;

	// 
	if (IsHandLance(hand_inf)) {
		type_hand[nhand++] = lance;
	}
	nolance = nhand;

	// 
	if (IsHandSilver(hand_inf)) {
		type_hand[nhand++] = silver;
	}

	// 
	if (IsHandGold(hand_inf)) {
		type_hand[nhand++] = gold;
	}

	// p
	if (IsHandBishop(hand_inf)) {
		type_hand[nhand++] = bishop;
	}

	// 
	if (IsHandRook(hand_inf)) {
		type_hand[nhand++] = rook;
	}

	// 1,2iڂŋ̑łĂƂ
	BBand(bb_rank1, bb_drop, black_mask_rank1);
	BBand(bb_rank2, bb_drop, black_mask_rank2);

	// 3iځ`9iڂ݂̂𒲂ׂ邽߂1`2iڂ̃rbg0ɂ
	bb_drop.p[0] &= 0x1FCU;
	bb_drop.p[1] &= 0x7F3F9FCFE7F3F9FCU;
	bb_drop.p[2] &= 0x1FCU;

	// i2̃`FbNj
	pawn_posi = BB_BPAWN;
	if (IsHandPawn(hand_inf)) {
		for (file = 0; file < 9; file++) {
			flag = 0;
			if (file == 0) {
				file_inf = pawn_posi.p[0];
			}
			else if (file == 8) {
				file_inf = pawn_posi.p[2];
			}
			else {
				file_inf = (pawn_posi.p[1] >> ((file - 1) * 9)) & 0x01FF;
			}
			if (file_inf > 0) {
				flag = 1;
			}
			if (flag == 1) { continue; };
			for (rank = 1; rank < 9; rank++) {
				if (BOARD[file * 9 + rank] == EMP) {
					to = file * 9 + rank;
					if (!is_mate_b_pawn_drop(ptree, to)) {
						ptree->Move[pmove++] = setmove(to, drop_pawn, 0, FU, 0);
					}
				}
			}
		}
	}

	// 3~9iڂ͂œ
	while (BBToU(bb_drop)) {
		to = FirstOne(bb_drop);
		for (i = 0; i < nhand; i++) {
			ptree->Move[pmove++] = setmove(to, 80 + type_hand[i], 0, type_hand[i], 0);
		}
		Xor(to, bb_drop);
	}

	// 2iڂ͌jnē
	while (BBToU(bb_rank2)) {
		to = FirstOne(bb_rank2);
		for (i = noknight; i < nhand; i++) {
			ptree->Move[pmove++] = setmove(to, 80 + type_hand[i], 0, type_hand[i], 0);
		}
		Xor(to, bb_rank2);
	}

	// 1iڂ͍Ԃē
	while (BBToU(bb_rank1)) {
		to = FirstOne(bb_rank1);
		for (i = nolance; i < nhand; i++) {
			ptree->Move[pmove++] = setmove(to, 80 + type_hand[i], 0, type_hand[i], 0);
		}
		Xor(to, bb_rank1);
	}

	return pmove;
}

int white_drop(tree_t *ptree, int pmove) {
	bitboard_t occ, bb_drop, bb_rank2, bb_rank1, pawn_posi;
	uint64 file_inf;
	int i, to, file, rank, flag;
	int nhand, nolance, noknight;
	int type_hand[6];
	unsigned int hand_inf;

	if (!HAND_W) { // 莝Ȃ
		return pmove;
	}

	BBor(occ, ptree->posi.b_occupied, ptree->posi.w_occupied); // Ֆʏŋꏊ
	BBNot(bb_drop, occ); // Ֆʏŋ̂Ȃꏊ

	hand_inf = HAND_W;
	nhand = 0;

	if (IsHandKnight(hand_inf)) {
		type_hand[nhand++] = KE;
	}
	noknight = nhand;
	if (IsHandLance(hand_inf)) {
		type_hand[nhand++] = KY;
	}
	nolance = nhand;
	if (IsHandSilver(hand_inf)) {
		type_hand[nhand++] = GI;
	}
	if (IsHandGold(hand_inf)) {
		type_hand[nhand++] = KI;
	}
	if (IsHandBishop(hand_inf)) {
		type_hand[nhand++] = KA;
	}
	if (IsHandRook(hand_inf)) {
		type_hand[nhand++] = HI;
	}

	BBand(bb_rank1, bb_drop, white_mask_rank1);
	BBand(bb_rank2, bb_drop, white_mask_rank2);

	bb_drop.p[0] &= 0x7FU;
	bb_drop.p[1] &= 0x1FCFE7F3F9FCFE7FU;
	bb_drop.p[2] &= 0x7FU;

	pawn_posi = BB_WPAWN;
	if (IsHandPawn(hand_inf)) {
		for (file = 0; file < 9; file++) {
			flag = 0;
			if (file == 0) {
				file_inf = pawn_posi.p[0];
			}
			else if (file == 8) {
				file_inf = pawn_posi.p[2];
			}
			else {
				file_inf = (pawn_posi.p[1] >> ((file - 1) * 9)) & 0x01FF;
			}
			if (file_inf > 0) {
				flag = 1;
			}
			if (flag == 1) { continue; };
			for (rank = 0; rank < 8; rank++) {
				if (BOARD[file * 9 + rank] == EMP) {
					to = file * 9 + rank;
					if (!is_mate_w_pawn_drop(ptree, to)) {
						ptree->Move[pmove++] = setmove(to, drop_pawn, 0, FU, 0);
					}
				}
			}
		}
	}
	while (BBToU(bb_drop)) {
		to = FirstOne(bb_drop);
		for (i = 0; i < nhand; i++) {
			ptree->Move[pmove++] = setmove(to, 80 + type_hand[i], 0, type_hand[i], 0);
		}
		Xor(to, bb_drop);
	}
	while (BBToU(bb_rank2)) {
		to = FirstOne(bb_rank2);
		for (i = noknight; i < nhand; i++) {
			ptree->Move[pmove++] = setmove(to, 80 + type_hand[i], 0, type_hand[i], 0);
		}
		Xor(to, bb_rank2);
	}
	while (BBToU(bb_rank1)) {
		to = FirstOne(bb_rank1);
		for (i = nolance; i < nhand; i++) {
			ptree->Move[pmove++] = setmove(to, 80 + type_hand[i], 0, type_hand[i], 0);
		}
		Xor(to, bb_rank1);
	}

	return pmove;
}