#include <cstdio>

#include "shogi.h"
#include "bitboard.h"

int black_nocapture(tree_t *ptree, int pmove)
{
	bitboard_t occ; // Ֆʏŋꏊ
	bitboard_t bb_empty; // Ֆʏŋ̂Ȃꏊ
	bitboard_t bb_piece, bb_buf;
	int to, from, piece, idirec;

	BBor(occ, ptree->posi.b_occupied, ptree->posi.w_occupied); // Ֆʏŋꏊ
	BBNot(bb_empty, occ); // Ֆʏŋ̂Ȃꏊ

	// 
	BBand(bb_piece, FUattacks(BB_BPAWN, black), bb_empty);
	while (BBToU(bb_piece)) {
		to = FirstOne(bb_piece);
		Xor(to, bb_piece);
		from = to + 1;
		if (DiscoverBK(from, to)) { continue; }
		if ((to % 9) <= 2) {
			ptree->Move[pmove++] = setmove(to, from, 1, pawn, 0);
		}
		else {
			ptree->Move[pmove++] = setmove(to, from, 0, pawn, 0);
		}
	}

	// 
	bb_piece = BB_BSILVER;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);
		BBand(bb_buf, bb_empty, b_silver_attacks[from]);
		while (BBToU(bb_buf)) {
			to = FirstOne(bb_buf);
			Xor(to, bb_buf);
			if (DiscoverBK(from, to)) { continue; }

			ptree->Move[pmove++] = setmove(to, from, 0, silver, 0);
			if (((((from % 9) >= 0) && ((from % 9) <= 2)) || (((to % 9) >= 0) && ((to % 9) <= 2)))) {
				ptree->Move[pmove++] = setmove(to, from, 1, silver, 0);
			}
		}
	}

	// 
	bb_piece = BB_BTGOLD;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		piece = BOARD[from] & 0x000F;
		Xor(from, bb_piece);
		BBand(bb_buf, bb_empty, b_gold_attacks[from]);
		while (BBToU(bb_buf)) {
			to = FirstOne(bb_buf);
			Xor(to, bb_buf);
			if (DiscoverBK(from, to)) { continue; }
			ptree->Move[pmove++] = setmove(to, from, 0, piece, 0);
		}
	}

	// 
	from = SQ_BKING;
	BBand(bb_buf, bb_empty, king_attacks[from]);
	while (BBToU(bb_buf)) {
		to = FirstOne(bb_buf);
		Xor(to, bb_buf);
		if (is_black_attacked(ptree, to)) { continue; }
		ptree->Move[pmove++] = setmove(to, from, 0, king, 0);
	}

	// p
	bb_piece = BB_BBISHOP;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);
		bb_buf = bishopAttacks(occ, from);
		BBand(bb_buf, bb_buf, bb_empty);
		while (BBToU(bb_buf)) {
			to = FirstOne(bb_buf);
			Xor(to, bb_buf);
			if (DiscoverBK(from, to)) { continue; }

			if (((((from % 9) >= 0) && ((from % 9) <= 2)) || (((to % 9) >= 0) && ((to % 9) <= 2)))) {
				ptree->Move[pmove++] = setmove(to, from, 1, bishop, 0);
			}
			else {
				ptree->Move[pmove++] = setmove(to, from, 0, bishop, 0);
			}
		}
	}

	// 
	bb_piece = BB_BROOK;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);
		bb_buf = rookAttacks(occ, from);
		BBand(bb_buf, bb_buf, bb_empty);
		while (BBToU(bb_buf)) {
			to = FirstOne(bb_buf);
			Xor(to, bb_buf);
			if (DiscoverBK(from, to)) { continue; }

			if (((((from % 9) >= 0) && ((from % 9) <= 2)) || (((to % 9) >= 0) && ((to % 9) <= 2)))) {
				ptree->Move[pmove++] = setmove(to, from, 1, rook, 0);
			}
			else {
				ptree->Move[pmove++] = setmove(to, from, 0, rook, 0);
			}
		}
	}

	// n
	bb_piece = BB_BHORSE;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);
		bb_buf = bishopAttacks(occ, from);
		BBor(bb_buf, bb_buf, king_attacks[from]);
		BBand(bb_buf, bb_buf, bb_empty);
		while (BBToU(bb_buf)) {
			to = FirstOne(bb_buf);
			Xor(to, bb_buf);
			if (DiscoverBK(from, to)) { continue; }

			ptree->Move[pmove++] = setmove(to, from, 0, horse, 0);
		}
	}

	// 
	bb_piece = BB_BDRAGON;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);
		bb_buf = rookAttacks(occ, from);
		BBor(bb_buf, bb_buf, king_attacks[from]);
		BBand(bb_buf, bb_buf, bb_empty);
		while (BBToU(bb_buf)) {
			to = FirstOne(bb_buf);
			Xor(to, bb_buf);
			if (DiscoverBK(from, to)) { continue; }

			ptree->Move[pmove++] = setmove(to, from, 0, dragon, 0);
		}
	}

	// 
	bb_piece = BB_BLANCE;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);
		bb_buf = AttackFile(from);
		BBand(bb_buf, bb_buf, plus_rays[from]);
		BBand(bb_buf, bb_buf, bb_empty);
		while (BBToU(bb_buf)) {
			to = FirstOne(bb_buf);
			Xor(to, bb_buf);
			if (DiscoverBK(from, to)) { continue; }

			if (to % 9 != 0) {
				ptree->Move[pmove++] = setmove(to, from, 0, lance, 0);
			}
			if (((to % 9) >= 0) && ((to % 9) <= 2)) {
				ptree->Move[pmove++] = setmove(to, from, 1, lance, 0);
			}
		}
	}

	// jn
	bb_piece = BB_BKNIGHT;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);
		BBand(bb_buf, bb_empty, b_knight_attacks[from]);
		while (BBToU(bb_buf)) {
			to = FirstOne(bb_buf);
			Xor(to, bb_buf);
			if (DiscoverBK(from, to)) { continue; }

			if (to % 9 >= 2) {// 1, 2iɌjn͋Ă͂ȂȂ
				ptree->Move[pmove++] = setmove(to, from, 0, knight, 0);
			}
			if (((to % 9) >= 0) && ((to % 9) <= 2)) {
				ptree->Move[pmove++] = setmove(to, from, 1, knight, 0);
			}
		}
	}
	return pmove;
}

int white_nocapture(tree_t *ptree, int pmove) {
	bitboard_t occ, bb_empty, bb_piece, bb_buf;
	int to, from, piece, idirec;

	BBor(occ, ptree->posi.b_occupied, ptree->posi.w_occupied); // Ֆʏŋꏊ
	BBNot(bb_empty, occ); // Ֆʏŋ̂Ȃꏊ

	BBand(bb_piece, FUattacks(BB_WPAWN, white), bb_empty); // Ȃňړo
	while (BBToU(bb_piece)) {
		to = FirstOne(bb_piece);
		Xor(to, bb_piece);
		from = to - 1;
		if (DiscoverWK(from, to)) { continue; }

		if ((to % 9) >= 6) {
			ptree->Move[pmove++] = setmove(to, from, 1, pawn, 0);
		}
		else {
			ptree->Move[pmove++] = setmove(to, from, 0, pawn, 0);
		}
	}

	bb_piece = BB_WSILVER;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);
		BBand(bb_buf, bb_empty, w_silver_attacks[from]);
		while (BBToU(bb_buf)) {
			to = FirstOne(bb_buf);
			Xor(to, bb_buf);
			if (DiscoverWK(from, to)) { continue; }

			ptree->Move[pmove++] = setmove(to, from, 0, silver, 0);
			if ((((from % 9) >= 6) && ((from % 9) <= 8)) || (((to % 9) >= 6) && ((to % 9) <= 8))) {
				ptree->Move[pmove++] = setmove(to, from, 1, silver, 0);
			}
		}
	}

	bb_piece = BB_WTGOLD;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);
		piece = BOARD[from] & 0x000F;
		BBand(bb_buf, bb_empty, w_gold_attacks[from]);
		while (BBToU(bb_buf)) {
			to = FirstOne(bb_buf);
			Xor(to, bb_buf);
			if (DiscoverWK(from, to)) { continue; }

			ptree->Move[pmove++] = setmove(to, from, 0, piece, 0);
		}
	}

	from = SQ_WKING;
	BBand(bb_buf, bb_empty, king_attacks[from]);
	while (BBToU(bb_buf)) {
		to = FirstOne(bb_buf);
		Xor(to, bb_buf);
		if (is_white_attacked(ptree, to)) { continue; }

		ptree->Move[pmove++] = setmove(to, from, 0, king, 0);
	}

	bb_piece = BB_WBISHOP;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);
		bb_buf = bishopAttacks(occ, from);
		BBand(bb_buf, bb_buf, bb_empty);
		while (BBToU(bb_buf)) {
			to = FirstOne(bb_buf);
			Xor(to, bb_buf);
			if (DiscoverWK(from, to)) { continue; }

			if ((((from % 9) >= 6) && ((from % 9) <= 8)) || (((to % 9) >= 6) && ((to % 9) <= 8))) {
				ptree->Move[pmove++] = setmove(to, from, 1, bishop, 0);
			}
			else {
				ptree->Move[pmove++] = setmove(to, from, 0, bishop, 0);
			}

		}
	}

	bb_piece = BB_WROOK;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);
		bb_buf = rookAttacks(occ, from);
		BBand(bb_buf, bb_buf, bb_empty);
		while (BBToU(bb_buf)) {
			to = FirstOne(bb_buf);
			Xor(to, bb_buf);
			if (DiscoverWK(from, to)) { continue; }

			if ((((from % 9) >= 6) && ((from % 9) <= 8)) || (((to % 9) >= 6) && ((to % 9) <= 8))) {
				ptree->Move[pmove++] = setmove(to, from, 1, rook, 0);
			}
			else {
				ptree->Move[pmove++] = setmove(to, from, 0, rook, 0);
			}
		}
	}

	bb_piece = BB_WHORSE;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);
		bb_buf = bishopAttacks(occ, from);
		BBor(bb_buf, bb_buf, king_attacks[from]);
		BBand(bb_buf, bb_buf, bb_empty);
		while (BBToU(bb_buf)) {
			to = FirstOne(bb_buf);
			Xor(to, bb_buf);
			if (DiscoverWK(from, to)) { continue; }

			ptree->Move[pmove++] = setmove(to, from, 0, horse, 0);
		}
	}

	bb_piece = BB_WDRAGON;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);
		bb_buf = rookAttacks(occ, from);
		BBor(bb_buf, bb_buf, king_attacks[from]);
		BBand(bb_buf, bb_buf, bb_empty);
		while (BBToU(bb_buf)) {
			to = FirstOne(bb_buf);
			Xor(to, bb_buf);
			if (DiscoverWK(from, to)) { continue; }

			ptree->Move[pmove++] = setmove(to, from, 0, dragon, 0);
		}
	}

	bb_piece = BB_WLANCE;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);
		bb_buf = AttackFile(from);
		BBand(bb_buf, bb_buf, minus_rays[from]);
		BBand(bb_buf, bb_buf, bb_empty);
		while (BBToU(bb_buf)) {
			to = FirstOne(bb_buf);
			Xor(to, bb_buf);
			if (DiscoverWK(from, to)) { continue; }

			if (to % 9 != 8) { // ŉiɍԂ͋Ă͂ȂȂ
				ptree->Move[pmove++] = setmove(to, from, 0, lance, 0);

			}
			if ((6 <= (to % 9)) && ((to % 9) <= 8)) {
				ptree->Move[pmove++] = setmove(to, from, 1, lance, 0);
			}
		}
	}

	bb_piece = BB_WKNIGHT;
	while (BBToU(bb_piece)) {
		from = FirstOne(bb_piece);
		Xor(from, bb_piece);
		BBand(bb_buf, bb_empty, w_knight_attacks[from]);
		while (BBToU(bb_buf)) {
			to = FirstOne(bb_buf);
			Xor(to, bb_buf);
			if (DiscoverWK(from, to)) { continue; }

			if (to % 9 <= 6) { // 8, 9iɌjn͋Ă͂ȂȂ
				ptree->Move[pmove++] = setmove(to, from, 0, knight, 0);
			}
			if (((to % 9) >= 6) && ((to % 9) <= 8)) {
				ptree->Move[pmove++] = setmove(to, from, 1, knight, 0);
			}
		}
	}
	return pmove;
}
