#include <utility>
#include "shogi.h"
#include "bitboard.h"
#include "USI.h"

void search(tree_t *ptree);

unsigned int pv[DEPTH_MAX]; // pv

void think(tree_t *ptree) {

	// PV(őP菇)
	for (int i = 0; i < DEPTH_MAX; i++) {
		pv[i] = MOVE_NONE;
	}

	// T
	search(ptree);

	// őPԂ
	if (pv[0] != MOVE_NONE) {
		printf("bestmove ");
		USI_move(pv[0]);
	}
	else {
		printf("bestmove resign");
	}
	printf("\n");
}

void search(tree_t *ptree)
{
	// ǖʂ̍@𐶐
	int numMove = genMove(ptree, TURN);

	// @肪ȂȂTI
	if (!numMove) {
		return;
	}

	// @
	for (int i = 0; i < numMove; ++i)
	{
		int j = rand() % numMove;
		std::swap(ptree->Move[i], ptree->Move[j]);
	}

	// [1ōől߂
	int bestValue = -MAX_VALUE;
	for (int i = 0; i < numMove; ++i)
	{
		MakeMove(TURN, ptree->Move[i]);
		int value = TURN ? -eval_material(ptree) : eval_material(ptree);;
		if (value > bestValue) {
			bestValue = value;
			pv[0] = ptree->Move[i];
		}
		UnMakeMove(TURN, ptree->Move[i]);
	}

	// ɏo
	Info(ptree, pv, bestValue);
}
