#ifndef SHOGI_H_INCLUDED
#define SHOGI_H_INCLUDED

#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <string>
#include <Winsock2.h>
#include <intrin.h>
#include "bit.h"
#include "platform.h"

#pragma intrinsic(_BitScanReverse64)
#pragma intrinsic(_BitScanForward64)

#define CONV	_fastcall
#define restrict __restrict

#define DEPTH_MAX 1		// őT[
#define MAX_MOVES 593	// ő升@萔
#define MAX_VALUE 30000 // ő̕]l

// o[W
#define ver "1.0"

#define BOARD (ptree->posi.asquare)
#define TURN (ptree->posi.turn) // 0ȂA1Ȃ
#define OCC(bb) BBor(bb,ptree->posi.b_occupied,ptree->posi.w_occupied) 
#define SQ_BKING (ptree->posi.isquare_b_king)
#define SQ_WKING (ptree->posi.isquare_w_king)
#define BB_BKING (abb_mask[SQ_BKING])
#define BB_WKING (abb_mask[SQ_WKING])

// 
#define HAND_B              (ptree->posi.hand_black)
#define HAND_W              (ptree->posi.hand_white)

// ŐV̎AŌ̎
#define MOVE_NONE           (0U)

#define AttackFile(i) file_attacks[i][occ.p[slide[i].slide_posi] >> slide[i].nslide & 0x7F] // ̎Zoۂ
#define AttackBLance(bb, sq) BBand(bb, plus_rays[sq], AttackFile(sq))
#define AttackWLance(bb, sq) BBand(bb, minus_rays[sq], AttackFile(sq))
#define AttackDragon(bb, sq) OCC(bb); rookAttacks(bb, sq); BBor(bb, bb, king_attacks[sq])
#define AttackHorse(bb, sq) OCC(bb); bishopAttacks(bb, sq); BBor(bb, bb, king_attacks[sq])

#define MoveCapture(turn, pmove)     ( (turn) ? white_capture( ptree, pmove ) : black_capture( ptree, pmove ) )
#define MoveNoCapture(turn, pmove)   ( (turn) ? white_nocapture( ptree, pmove ) : black_nocapture( ptree, pmove ) )
#define MoveDrop(turn, pmove)        ( (turn) ? white_drop( ptree, pmove ) : black_drop( ptree, pmove ) )
#define MoveEvasionKing(turn, pmove) ( (turn) ? w_king_evasion( ptree, pmove ) : b_king_evasion( ptree, pmove ) )

/*
xxxxxxxx xxxxxxxx x1111111  destination ړ
xxxxxxxx xx111111 1xxxxxxx  starting square or drop piece+nsquare-1 ړ łꍇ͂WPZ
xxxxxxxx x1xxxxxx xxxxxxxx  flag for promotion@tO
xxxxx111 1xxxxxxx xxxxxxxx  piece to move@ړ̎
x1111xxx xxxxxxxx xxxxxxxx  captured piece@ߊl̎

@ߊl͎̂ƖȂ̂ŁAhashɊi[Ƃ͍폜
19bitƂĕ\łB
@܂piece4bitŕ\Ă̋ʂ͂ɂ͂ȂB
Č̋𕉂̒lŕ\ĂȂAΒlƂĂi[KvB
*/

#define ToMove(to)		 ((unsigned int)(to)	<<  0)
#define FromMove(from)	 ((unsigned int)(from)	<<  7)
#define flag_promo       ((flag)                << 14) // Ȃflag = 1, ȂȂflag = 0
#define PieceMove(piece) ((unsigned int)(piece)	<< 15)
#define CapPiece(cap)	 ((cap)					<< 19)

#define GetMoveTo(move)         (((move) >>  0) & 0x007fU)
#define GetMoveFrom(move)       (((move) >>  7) & 0x007fU)
#define GetMovePromoted(move)   (((move) >> 14) & 0x0001U)
#define GetMovePiece(move)      (((move) >> 15) & 0x000fU)
#define GetMoveCapPiece(move)   (((move) >> 19) & 0x000fU)

#define DropPiece(from)         ((from)-nsquare+1)
/*
xxxxxxxx xxxxxxxx xxx11111  pawn		
xxxxxxxx xxxxxxxx 111xxxxx  lance		
xxxxxxxx xxxxx111 xxxxxxxx  knight	j
xxxxxxxx xx111xxx xxxxxxxx  silver	
xxxxxxx1 11xxxxxx xxxxxxxx  gold		
xxxxx11x xxxxxxxx xxxxxxxx  bishop	p
xxx11xxx xxxxxxxx xxxxxxxx  rook		
*/

/*   XX 邩
*  I2͖AIs͗LԂ
*/
/* I2͖ */

#define I2HandPawn(hand)       (((hand) >>  0) & 0x1f)
#define I2HandLance(hand)      (((hand) >>  5) & 0x07)
#define I2HandKnight(hand)     (((hand) >>  8) & 0x07)
#define I2HandSilver(hand)     (((hand) >> 11) & 0x07)
#define I2HandGold(hand)       (((hand) >> 14) & 0x07)
#define I2HandBishop(hand)     (((hand) >> 17) & 0x03)
#define I2HandRook(hand)        ((hand) >> 19)

/* Is͂邩Ȃ
* VtĝŐmȐ킩ȂCɍ
*/

#define IsHandPawn(hand)       ((hand) & 0x000001f)
#define IsHandLance(hand)      ((hand) & 0x00000e0)
#define IsHandKnight(hand)     ((hand) & 0x0000700)
#define IsHandSilver(hand)     ((hand) & 0x0003800)
#define IsHandGold(hand)       ((hand) & 0x001c000)
#define IsHandBishop(hand)     ((hand) & 0x0060000)
#define IsHandRook(hand)       ((hand) & 0x0180000)

#define MakeMove(turn, move)   ((turn) ? make_move_w(ptree, move) : make_move_b(ptree, move))
#define UnMakeMove(turn, move) ((turn) ? unmake_move_w(ptree, move) : unmake_move_b(ptree, move))

#define Check(turn)   ( (turn) ? is_white_attacked(ptree, SQ_WKING) : is_black_attacked(ptree, SQ_BKING) )
#define Check_move(turn, move) ( (turn) ? move_check_w(ptree,move) : move_check_b(ptree,move) )

#define DiscoverBK(from, to)                \
	idirec = (int)adirec[SQ_BKING][from],  \
	( idirec && ( idirec != (int)adirec[SQ_BKING][to] )  \
		&& pinned_black_king(ptree, from, idirec) )

#define DiscoverWK(from, to)                \
	idirec = (int)adirec[SQ_WKING][from],  \
	( idirec && ( idirec != (int)adirec[SQ_WKING][to] )  \
	    && pinned_white_king(ptree, from, idirec) )

// ɂʂ̑łl߂̃`FbN
#define IsMateWPawnDrop(ptree, to) ( BOARD[(to)+1] == king                 \
                                     && is_mate_w_pawn_drop( ptree, to ) )
// ɂʂ̑łl߂̃`FbN
#define IsMateBPawnDrop(ptree, to) ( BOARD[(to)-1] == -king                \
                                     && is_mate_b_pawn_drop( ptree, to ) )

enum {
	b0000, b0001, b0010, b0011, b0100, b0101, b0110, b0111,
	b1000, b1001, b1010, b1011, b1100, b1101, b1110, b1111
};

/* Ӗbit */
enum {
	direc_misc = b0000,				// c΂߂̊֌WɂȂꍇ
	direc_file = b0010,/* | */		// c̊֌Włꍇ
	direc_rank = b0011,/* - */		// ̊֌Włꍇ
	direc_diag1 = b0100,/* / */		// Eォ獶̎΂ߊ֌Włꍇ
	direc_diag2 = b0101,/* \(_) */	// ォE̎΂ߊ֌Włꍇ
	flag_cross = b0010,/* + */		// cƉȂΎĂbitmask
	flag_diag = b0100 /*~ */		// ΂ߕȂΎĂbitmask
};


enum {
	nfile = 9,	//؂̐ij
	nrank = 9,	//i̐isj
	nsquare = 81	//ڂ̐
};

enum {
	drop_pawn = 81,
	drop_lance,
	drop_knight,
	drop_silver,
	drop_gold,
	drop_bishop,
	drop_rook
};

enum { rank1 = 0, rank2, rank3, rank4, rank5, rank6, rank7, rank8, rank9 };
enum { file1 = 0, file2, file3, file4, file5, file6, file7, file8, file9 };

/* @+8ɂȂ悤ɂĂ */
enum PieceType {
	empty = 0,
	pawn,
	lance,
	knight,
	silver,
	gold,
	bishop,
	rook,
	king,
	pro_pawn,
	pro_lance,
	pro_knight,
	pro_silver,
	null,
	horse,
	dragon,

	promote = 8,
	enemy = 16,
	black = 0,
	white = 1
};

enum {
	w_pawn = pawn + enemy,
	w_lance = lance + enemy,
	w_knight = knight + enemy,
	w_silver = silver + enemy,
	w_gold = gold + enemy,
	w_bishop = bishop + enemy,
	w_rook = rook + enemy,
	w_king = king + enemy,
	w_pro_pawn = pro_pawn + enemy,
	w_pro_lance = pro_lance + enemy,
	w_pro_knight = pro_knight + enemy,
	w_pro_silver = pro_silver + enemy,
	w_horse = horse + enemy,
	w_dragon = dragon + enemy
};

enum {
	flag_hand_pawn = 1 << 0,
	flag_hand_lance = 1 << 5,
	flag_hand_knight = 1 << 8,
	flag_hand_silver = 1 << 11,
	flag_hand_gold = 1 << 14,
	flag_hand_bishop = 1 << 17,
	flag_hand_rook = 1 << 19
};


/*̂Q\*/
#define EM  empty
#define FU  pawn
#define KY  lance
#define KE  knight
#define GI  silver
#define KI  gold
#define KA  bishop
#define HI  rook
#define OU  king
#define TO  pro_pawn
#define NY  pro_lance
#define NK  pro_knight
#define NG  pro_silver
#define UM  horse
#define RY  dragon

/***
* ̂R\i8bitsj
* xxxxx111    // ̎
* xxxx1xxx    // ǂ
* xxx1xxxx    // 肩肩
*/

/* ̂R\ */
#define EMP  PieceType::empty
#define BFU  PieceType::pawn
#define BKY  PieceType::lance
#define BKE  PieceType::knight
#define BGI  PieceType::silver
#define BKI  PieceType::gold
#define BKA  PieceType::bishop
#define BHI  PieceType::rook
#define BOU  PieceType::king
#define BTO  PieceType::pro_pawn
#define BNY  PieceType::pro_lance
#define BNK  PieceType::pro_knight
#define BNG  PieceType::pro_silver
#define BUM  PieceType::horse
#define BRY  PieceType::dragon
#define WFU  w_pawn
#define WKY  w_lance
#define WKE  w_knight
#define WGI  w_silver
#define WKI  w_gold
#define WKA  w_bishop
#define WHI  w_rook
#define WOU  w_king
#define WTO  w_pro_pawn
#define WNY  w_pro_lance
#define WNK  w_pro_knight
#define WNG  w_pro_silver
#define WUM  w_horse
#define WRY  w_dragon

/* ǖ */
typedef struct Position {

	/* --- ebitboard --- */
	/* b_ black() , w_ while() */

	/* /̗̋L(1) */
	/* maskɂ͉܂܂B */
	bitboard_t b_occupied, w_occupied;

	/* ñrbg}bv̘_a(horse,dragon,king) */
	bitboard_t b_hdk, w_hdk;

	/* A̗̈ʒurbg}bv */
	bitboard_t b_tgold, w_tgold;

	/* pn݂̑rbg}bv̘_a(bishop,horse) */
	bitboard_t b_bh, w_bh;

	/* 򗴂̗rbg}bv̘_a(rook,dragon) */
	bitboard_t b_rd, w_rd;

	/* ȇ݂Ƃ낪1łrbg}bv */
	bitboard_t b_lance, w_lance;		// 
	bitboard_t b_knight, w_knight;		// jn
	bitboard_t b_silver, w_silver;		// 
	bitboard_t b_bishop, w_bishop;		// p
	bitboard_t b_rook, w_rook;			// 
	bitboard_t b_horse, w_horse;		// n
	bitboard_t b_dragon, w_dragon;		// 
	bitboard_t b_pawn, w_pawn;			// 
	bitboard_t b_gold, w_gold;			// 
	bitboard_t b_pro_pawn, w_pro_pawn;		// 
	bitboard_t b_pro_lance, w_pro_lance;	// 
	bitboard_t b_pro_knight, w_pro_knight;	// j
	bitboard_t b_pro_silver, w_pro_silver;	// 

											/*  */
	unsigned int hand_black, hand_white;

	/* 81}XBɑ݂̒lĂB */
	/* ̈ړɍۂẮAbitboard̑ɂ̔z̒lXVB */
	int asquare[nsquare];

	/* ʂ̈ʒuAE */
	/* ̐lՏ̂ǂ̈ʒuӖ邩́AbitboardFirstOneQlɂ邱ƁB */
	unsigned char isquare_b_king, isquare_w_king;

	/*  */
	int turn;
} posi_t;


typedef struct {
	bitboard_t mask;
	uint64 magic[2];
	int shift;
} GMagic;

typedef struct {
	int nslide;
	int slide_posi;
} slide_t;

/* T؂̍\ */
struct tree_t {

	// ǖʂ̏
	posi_t posi;

	// 萔
	unsigned int tesu;

	// @
	unsigned int Move[MAX_MOVES];
};

//֐`
int CONV last_one012(unsigned long long u2, unsigned long long u1, unsigned long long u0);
int CONV first_one012(unsigned long long  u2, unsigned long long  u1, unsigned long long u0);
int CONV bitcount(unsigned long long u0, unsigned long long u1, unsigned long long u2);

//ini.cpp
void ini_prepare(tree_t *ptree);
void hirate(tree_t *ptree);
void custom(tree_t *ptree);
void set_attacks(int irank, int ifilea, bitboard_t * pbb);
int set_bitboard(tree_t *ptree);
void ini_attack_tables(tree_t *ptree);

//procedure.cpp
void procedure(char *commandstr, tree_t *ptree);

//utility.cpp
unsigned int setmove(int to, int from, int flag, int piece, int cap);

bitboard_t bb_set_mask(int sq);

//move.cpp
int genMove(tree_t *ptree, int turn);

//move_cap.cpp
int black_capture(tree_t *ptree, int pmove);
int white_capture(tree_t *ptree, int pmove);

//move_nocap.cpp
int black_nocapture(tree_t *ptree, int pmove);
int white_nocapture(tree_t *ptree, int pmove);

//move_drop.cpp
int black_drop(tree_t *ptree, int pmove);
int white_drop(tree_t *ptree, int pmove);

//evasion_king.cpp
int b_king_evasion(tree_t *ptree, int pmove);
int w_king_evasion(tree_t *ptree, int pmove);

//make_move.cpp
void CONV make_move_b(tree_t *ptree, unsigned int move);
void CONV make_move_w(tree_t *ptree, unsigned int move);

//unmake_move.cpp
void CONV unmake_move_b(tree_t *ptree, unsigned int move);
void CONV unmake_move_w(tree_t *ptree, unsigned int move);

//magic.cpp
int magic(void);
int transform(uint64 b, uint64 magic, int bits);
int transform2(uint64 b, uint64 a, uint64 magic1, uint64 magic2, int bits);
int transform3(uint64 b, uint64 a, uint64 magic1, uint64 magic2, int bits);

//mask.cpp
uint64 rmask(int sq);
uint64 sidermask(int sq);
uint64 bmask(int sq);
uint64 sidebmask(int sq);
uint64 sidemask(int sq);
uint64 ratt(int sq, uint64 block, bitboard_t* result);
uint64 ratt2(int sq, uint64 block);
uint64 ratt3(int sq, uint64 block, bitboard_t* result);
uint64 batt(int sq, uint64 block, bitboard_t* result);
uint64 batt2(int sq, uint64 block, bitboard_t* result);
bitboard_t AttackRank(int from, bitboard_t occ);
bitboard_t AttackDiag1(int from, bitboard_t occ);
bitboard_t AttackDiag2(int from, bitboard_t occ);
bitboard_t mask_diag1(int sq, bitboard_t bb);
bitboard_t mask_diag2(int sq, bitboard_t bb);

//evalate.cpp
int CONV eval_material(const tree_t * restrict ptree);

//search.cpp
void think(tree_t *ptree);

//attack.cpp
uint64 pinned_black_king(tree_t *ptree, int sq, int idirec);
uint64 pinned_white_king(tree_t *ptree, int sq, int idirec);
uint64 is_white_attacked(tree_t *ptree, int sq);
uint64 is_black_attacked(tree_t *ptree, int sq);
bitboard_t CONV attacks_to_piece(tree_t * restrict ptree, int sq);
bitboard_t b_attacks_to_piece(tree_t *ptree, int sq);
bitboard_t w_attacks_to_piece(tree_t *ptree, int sq);
uint64  move_check_b(tree_t *ptree, unsigned int move);
uint64  move_check_w(tree_t *ptree, unsigned int move);
bitboard_t FUattacks(bitboard_t b, int turn);
bitboard_t bishopAttacks(bitboard_t occ, int sq);
bitboard_t rookAttacks(bitboard_t occ, int sq);
// is_mate_b_pawn_droṕAɂʂ̑łl݃`FbN
// is_mate_w_pawn_droṕAɂʂ̑łl݃`FbN
// sq_drop = łƂƂꏊ
// łl߂ȂtrueԂB
// ɂ֑ɂȂł̉̃`FbN͂Ɋ܂܂ȂB
int CONV is_mate_w_pawn_drop(tree_t * restrict ptree, int sq_drop);
int CONV is_mate_b_pawn_drop(tree_t * restrict ptree, int sq_drop);

//valid.cpp
int move_valid(tree_t *ptree, unsigned int move, int turn);

extern GMagic mBishoptbl[81];
extern GMagic mRooktbl[81];
extern GMagic mNewRooktbl[81];

extern bool Infinite;						// vlԂǂ

extern unsigned long remainTime;			// c莞
extern unsigned long byoyomiTime;			// bǂ
extern unsigned long incrementTime;			// tBbV[[pZ

extern const char *rankSFENNameArray[];			// SFENp
extern const char *mochiGomaSFENNameArray[];	// 

extern int p_value[32];

extern const int  init_board[81];
extern slide_t slide[nsquare];
extern unsigned char adirec[nsquare][nsquare];
extern bitboard_t file_attacks[nsquare][128];
extern bitboard_t rank_attacks[nsquare][128];
extern bitboard_t obstacle[nsquare][nsquare];
extern bitboard_t plus_rays[nsquare];
extern bitboard_t minus_rays[nsquare];
extern const int BitTable[64];
extern int RBits[64];
extern int BBits[64];
extern int sideRBit[9];
extern int sideBBit[9];
extern bitboard_t black_mask_rank1;
extern bitboard_t black_mask_rank2;
extern bitboard_t white_mask_rank1;
extern bitboard_t white_mask_rank2;

#define SET_MOVE(to , from , flag , piece , cap) (setmove(to , from , flag , piece , cap))
#define FU_ATTACKS(attacks , bb , turn) (attacks = FUattacks(bb , turn))

const enum PLAYER {
	BLACK = 0,
	WHITE = 1,
};

#endif // #ifndef SHOGI_H_INCLUDED

