#include <cstdio>
#include "shogi.h"
#include "bitboard.h"

#define CapB(PIECE, piece, pro_piece) \
	Xor(to, BB_B ## PIECE);           \
	HAND_W -= flag_hand_ ## piece;	  \
	BOARD[to] = pro_piece;

#define CapW(PIECE, piece, pro_piece) \
	Xor(to, BB_W ##  PIECE);          \
	HAND_B -= flag_hand_ ## piece;	  \
	BOARD[to] = pro_piece + enemy;

#define NoCapPro(PIECE, PRO_PIECE, piece) \
	Xor(from, BB_ ## PIECE);              \
	Xor(to, BB_ ## PRO_PIECE);            \
	BOARD[from] = piece;

#define NoCapNoPro(PIECE, piece) \
	SetClear(BB_ ## PIECE);		 \
	BOARD[from] = piece;

void CONV unmake_move_b(tree_t *ptree, unsigned int move)
{

	int from = (int)GetMoveFrom(move);
	int to = (int)GetMoveTo(move);

	// ł
	if (from >= nsquare) {

		switch (DropPiece(from)) {
		case pawn:
			Xor(to, BB_BPAWN);
			HAND_B += flag_hand_pawn;
			break;
		case lance:
			Xor(to, BB_BLANCE);
			HAND_B += flag_hand_lance;
			break;
		case knight:
			Xor(to, BB_BKNIGHT);
			HAND_B += flag_hand_knight;
			break;
		case silver:
			Xor(to, BB_BSILVER);
			HAND_B += flag_hand_silver;
			break;
		case gold:
			Xor(to, BB_BGOLD);
			Xor(to, BB_BTGOLD);
			HAND_B += flag_hand_gold;
			break;
		case bishop:
			Xor(to, BB_BBISHOP);
			Xor(to, BB_B_BH);
			HAND_B += flag_hand_bishop;
			break;
		case rook:
			Xor(to, BB_BROOK);
			Xor(to, BB_B_RD);
			HAND_B += flag_hand_rook;
			break;
		default:
			break;
		}

		BOARD[to] = EMP;
		Xor(to, BB_BOCCUPY);
	}

	// Ֆʏ̋
	else {
		const int promote = (int)GetMovePromoted(move);
		const int move_piece = (int)GetMovePiece(move);
		const int cap_piece = (int)GetMoveCapPiece(move);
		bitboard_t bb_set_clear;

		BBor(bb_set_clear, abb_mask[from], abb_mask[to]); // ړAړ1bitboard
		SetClear(BB_BOCCUPY);

		// 肠
		if (promote) {

			switch (move_piece) {
			case pawn:
				NoCapPro(BPAWN, BPRO_PAWN, pawn);
				Xor(to, BB_BTGOLD);
				break;
			case lance:
				NoCapPro(BLANCE, BPRO_LANCE, lance);
				Xor(to, BB_BTGOLD);
				break;
			case knight:
				NoCapPro(BKNIGHT, BPRO_KNIGHT, knight);
				Xor(to, BB_BTGOLD);
				break;
			case silver:
				NoCapPro(BSILVER, BPRO_SILVER, silver);
				Xor(to, BB_BTGOLD);
				break;
			case bishop:
				NoCapPro(BBISHOP, BHORSE, bishop);
				Xor(to, BB_B_HDK);
				SetClear(BB_B_BH);
				break;
			case rook:
				NoCapPro(BROOK, BDRAGON, rook);
				Xor(to, BB_B_HDK);
				SetClear(BB_B_RD);
				break;
			default:
				break;
			}
		}

		// Ȃ
		else {

			switch (move_piece) {
			case pawn:
				NoCapNoPro(BPAWN, pawn);
				break;
			case lance:
				NoCapNoPro(BLANCE, lance);
				break;
			case knight:
				NoCapNoPro(BKNIGHT, knight);
				break;
			case silver:
				NoCapNoPro(BSILVER, silver);
				break;
			case gold:
				NoCapNoPro(BGOLD, gold);
				SetClear(BB_BTGOLD);
				break;
			case bishop:
				NoCapNoPro(BBISHOP, bishop);
				SetClear(BB_B_BH);
				break;
			case rook:
				NoCapNoPro(BROOK, rook);
				SetClear(BB_B_RD);
				break;
			case king:
				BOARD[from] = king;
				SQ_BKING = (char)from;
				SetClear(BB_B_HDK);
				break;
			case pro_pawn:
				NoCapNoPro(BPRO_PAWN, pro_pawn);
				SetClear(BB_BTGOLD);
				break;
			case pro_lance:
				NoCapNoPro(BPRO_LANCE, pro_lance);
				SetClear(BB_BTGOLD);
				break;
			case pro_knight:
				NoCapNoPro(BPRO_KNIGHT, pro_knight);
				SetClear(BB_BTGOLD);
				break;
			case pro_silver:
				NoCapNoPro(BPRO_SILVER, pro_silver);
				SetClear(BB_BTGOLD);
				break;
			case horse:
				NoCapNoPro(BHORSE, horse);
				SetClear(BB_B_HDK);
				SetClear(BB_B_BH);
				break;
			case dragon:
				NoCapNoPro(BDRAGON, dragon);
				SetClear(BB_B_HDK);
				SetClear(BB_B_RD);
				break;
			default:
				break;
			}
		}

		// 
		if (cap_piece) {

			switch (cap_piece) {
			case pawn:
				CapW(PAWN, pawn, pawn);
				break;
			case lance:
				CapW(LANCE, lance, lance);
				break;
			case knight:
				CapW(KNIGHT, knight, knight);
				break;
			case silver:
				CapW(SILVER, silver, silver);
				break;
			case gold:
				CapW(GOLD, gold, gold);
				Xor(to, BB_WTGOLD);
				break;
			case bishop:
				CapW(BISHOP, bishop, bishop);
				Xor(to, BB_W_BH);
				break;
			case rook:
				CapW(ROOK, rook, rook);
				Xor(to, BB_W_RD);
				break;
			case pro_pawn:
				CapW(PRO_PAWN, pawn, pro_pawn);
				Xor(to, BB_WTGOLD);
				break;
			case pro_lance:
				CapW(PRO_LANCE, lance, pro_lance);
				Xor(to, BB_WTGOLD);
				break;
			case pro_knight:
				CapW(PRO_KNIGHT, knight, pro_knight);
				Xor(to, BB_WTGOLD);
				break;
			case pro_silver:
				CapW(PRO_SILVER, silver, pro_silver);
				Xor(to, BB_WTGOLD);
				break;
			case horse:
				CapW(HORSE, bishop, horse);
				Xor(to, BB_W_HDK);
				Xor(to, BB_W_BH);
				break;
			case dragon:
				CapW(DRAGON, rook, dragon);
				Xor(to, BB_W_HDK);
				Xor(to, BB_W_RD);
				break;
			default:
				break;
			}

			Xor(to, BB_WOCCUPY);
		}
		else {

			BOARD[to] = EMP;
		}
	}
}

void CONV unmake_move_w(tree_t *ptree, unsigned int move)
{
	int from = (int)GetMoveFrom(move);
	int to = (int)GetMoveTo(move);

	// ł
	if (from >= nsquare) {

		switch (DropPiece(from)) {
		case pawn:
			Xor(to, BB_WPAWN);
			HAND_W += flag_hand_pawn;
			break;
		case lance:
			Xor(to, BB_WLANCE);
			HAND_W += flag_hand_lance;
			break;
		case knight:
			Xor(to, BB_WKNIGHT);
			HAND_W += flag_hand_knight;
			break;
		case silver:
			Xor(to, BB_WSILVER);
			HAND_W += flag_hand_silver;
			break;
		case gold:
			Xor(to, BB_WGOLD);
			Xor(to, BB_WTGOLD);
			HAND_W += flag_hand_gold;
			break;
		case bishop:
			Xor(to, BB_WBISHOP);
			Xor(to, BB_W_BH);
			HAND_W += flag_hand_bishop;
			break;
		case rook:
			Xor(to, BB_WROOK);
			Xor(to, BB_W_RD);
			HAND_W += flag_hand_rook;
			break;
		default:
			break;
		}
		BOARD[to] = EMP;
		Xor(to, BB_WOCCUPY);
	}

	// Ֆʏ̋
	else {
		const int promote = (int)GetMovePromoted(move);
		const int move_piece = (int)GetMovePiece(move);
		const int cap_piece = (int)GetMoveCapPiece(move);
		bitboard_t bb_set_clear;

		BBor(bb_set_clear, abb_mask[from], abb_mask[to]);
		SetClear(BB_WOCCUPY);

		// 
		if (promote) {

			switch (move_piece) {
			case pawn:
				NoCapPro(WPAWN, WPRO_PAWN, pawn + enemy);
				Xor(to, BB_WTGOLD);
				break;
			case lance:
				NoCapPro(WLANCE, WPRO_LANCE, lance + enemy);
				Xor(to, BB_WTGOLD);
				break;
			case knight:
				NoCapPro(WKNIGHT, WPRO_KNIGHT, knight + enemy);
				Xor(to, BB_WTGOLD);
				break;
			case silver:
				NoCapPro(WSILVER, WPRO_SILVER, silver + enemy);
				Xor(to, BB_WTGOLD);
				break;
			case bishop:
				NoCapPro(WBISHOP, WHORSE, bishop + enemy);
				Xor(to, BB_W_HDK);
				SetClear(BB_W_BH);
				break;
			case rook:
				NoCapPro(WROOK, WDRAGON, rook + enemy);
				Xor(to, BB_W_HDK);
				SetClear(BB_W_RD);
				break;
			}
		}

		// 炸
		else {

			switch (move_piece) {
			case pawn:
				NoCapNoPro(WPAWN, pawn + enemy);
				break;
			case lance:
				NoCapNoPro(WLANCE, lance + enemy);
				break;
			case knight:
				NoCapNoPro(WKNIGHT, knight + enemy);
				break;
			case silver:
				NoCapNoPro(WSILVER, silver + enemy);
				break;
			case gold:
				NoCapNoPro(WGOLD, gold + enemy);
				SetClear(BB_WTGOLD);
				break;
			case bishop:
				NoCapNoPro(WBISHOP, bishop + enemy);
				SetClear(BB_W_BH);
				break;
			case rook:
				NoCapNoPro(WROOK, rook + enemy);
				SetClear(BB_W_RD);
				break;
			case king:
				BOARD[from] = king + enemy;
				SQ_WKING = (char)from;
				SetClear(BB_W_HDK);
				break;
			case pro_pawn:
				NoCapNoPro(WPRO_PAWN, pro_pawn + enemy);
				SetClear(BB_WTGOLD);
				break;
			case pro_lance:
				NoCapNoPro(WPRO_LANCE, pro_lance + enemy);
				SetClear(BB_WTGOLD);
				break;
			case pro_knight:
				NoCapNoPro(WPRO_KNIGHT, pro_knight + enemy);
				SetClear(BB_WTGOLD);
				break;
			case pro_silver:
				NoCapNoPro(WPRO_SILVER, pro_silver + enemy);
				SetClear(BB_WTGOLD);
				break;
			case horse:
				NoCapNoPro(WHORSE, horse + enemy);
				SetClear(BB_W_HDK);
				SetClear(BB_W_BH);
				break;
			case dragon:
				NoCapNoPro(WDRAGON, dragon + enemy);
				SetClear(BB_W_HDK);
				SetClear(BB_W_RD);
				break;
			default:
				break;
			}
		}

		// 
		if (cap_piece) {

			switch (cap_piece) {
			case pawn:
				CapB(PAWN, pawn, pawn);
				break;
			case lance:
				CapB(LANCE, lance, lance);
				break;
			case knight:
				CapB(KNIGHT, knight, knight);
				break;
			case silver:
				CapB(SILVER, silver, silver);
				break;
			case gold:
				CapB(GOLD, gold, gold);
				Xor(to, BB_BTGOLD);
				break;
			case bishop:
				CapB(BISHOP, bishop, bishop);
				Xor(to, BB_B_BH);
				break;
			case rook:
				CapB(ROOK, rook, rook);
				Xor(to, BB_B_RD);
				break;
			case pro_pawn:
				CapB(PRO_PAWN, pawn, pro_pawn);
				Xor(to, BB_BTGOLD);
				break;
			case pro_lance:
				CapB(PRO_LANCE, lance, pro_lance);
				Xor(to, BB_BTGOLD);
				break;
			case pro_knight:
				CapB(PRO_KNIGHT, knight, pro_knight);
				Xor(to, BB_BTGOLD);
				break;
			case pro_silver:
				CapB(PRO_SILVER, silver, pro_silver);
				Xor(to, BB_BTGOLD);
				break;
			case horse:
				CapB(HORSE, bishop, horse);
				Xor(to, BB_B_HDK);
				Xor(to, BB_B_BH);
				break;
			case dragon:
				CapB(DRAGON, rook, dragon);
				Xor(to, BB_B_HDK);
				Xor(to, BB_B_RD);
				break;
			default:
				break;
			}
			Xor(to, BB_BOCCUPY);
		}
		else {
			BOARD[to] = EMP;
		}
	}
}