#include <cstdio>
#include <iostream>
#include <sstream>
#include <string>
#include "shogi.h"
#include "bitboard.h"
#include "usi.h"
#include "platform.h"

using namespace std;

static char komaSFENNameArray[] = { ' ', 'P', 'L', 'N', 'S', 'G', 'B', 'R', 'K' };	// SFEN`ł̎̕ij
static char komaSFENNameArray2[] = { ' ', 'p', 'l', 'n', 's', 'g', 'b', 'r', 'k' }; // 

#define HAND_BLACK(piece)		  \
	HAND_B += flag_hand_ ## piece \

#define HAND_WHITE(piece)		  \
	HAND_W += flag_hand_ ## piece \

KomaInf MochigomaSFENKomaNameToValue(char komaName, int turn) {
	int i;

	for (i = 1; i <= 7; i++) { // ͎ɂȂȂ̂7܂
		if (komaName == komaSFENNameArray[i]) {
			if (turn) {
				return (KomaInf)(i)+enemy;
			}
			else {
				return (KomaInf)(i);
			}
		}
	}
	return 0;
}

KomaInf SFENKomaNameToValue(char komaName) {

	for (int i = 1; i <= 8; i++) {
		if (komaName == komaSFENNameArray[i])
		{
			return (KomaInf)(i);
		}
		if (komaName == komaSFENNameArray2[i])
		{
			return (KomaInf)(i)+enemy;
		}
	}
	return 0;
}


void MakeCustom(char *buf, tree_t *ptree) {
	int pos = (int)strlen("position sfen ");
	char *ptr = buf + pos;
	int num, i;
	int rank, file;
	KomaInf koma;

	HAND_B = 0ULL;
	HAND_W = 0ULL;
	for (rank = 0; rank <= 8; rank++) {
		file = 8; //91Ƃčl
		while (file >= 0) {
			if (*ptr == '/') { //rank̕ύX
				++ptr;
			}
			else if (*ptr >= '1' && *ptr <= '9') { //A󔒃}X̐
				sscanf(ptr, "%1d", &num);
				for (i = 0; i < num; i++) {
					ptree->posi.asquare[file * 9 + rank] = EMP; //ڂɋ󔒂̃f[^
					file--;
				}
				++ptr;
			}
			else if (*ptr == '+') { //ǂ
				++ptr;
				koma = SFENKomaNameToValue(*ptr) + promote;
				ptree->posi.asquare[file * 9 + rank] = koma;
				++ptr;
				file--;
			}
			else {
				koma = SFENKomaNameToValue(*ptr);
				ptree->posi.asquare[file * 9 + rank] = koma;
				++ptr;
				file--;
			}
		}
	}

	ptr += 3;
	while (*ptr != ' ') {
		num = 1;
		if (*ptr >= '1' && *ptr <= '9') {
			if (*(ptr + 1) >= '0' && *(ptr + 1) <= '9') {
				sscanf(ptr, "%2d", &num); //2̐
				ptr += 2;
			}
			else {
				sscanf(ptr, "%1d", &num);
				ptr += 1;
			}
		}
		koma = SFENKomaNameToValue(*ptr);
		for (i = 0; i < num; i++) {
			if (koma > 16) {
				switch (koma - 16) {
				case pawn:
					HAND_WHITE(pawn);
					break;
				case lance:
					HAND_WHITE(lance);
					break;
				case knight:
					HAND_WHITE(knight);
					break;
				case silver:
					HAND_WHITE(silver);
					break;
				case gold:
					HAND_WHITE(gold);
					break;
				case bishop:
					HAND_WHITE(bishop);
					break;
				case rook:
					HAND_WHITE(rook);
					break;
				default:
					break;
				}
			}
			else {
				switch (koma) {
				case pawn:
					HAND_BLACK(pawn);
					break;
				case lance:
					HAND_BLACK(lance);
					break;
				case knight:
					HAND_BLACK(knight);
					break;
				case silver:
					HAND_BLACK(silver);
					break;
				case gold:
					HAND_BLACK(gold);
					break;
				case bishop:
					HAND_BLACK(bishop);
					break;
				case rook:
					HAND_BLACK(rook);
					break;
				default:
					break;
				}
			}
		}
		++ptr;
	}
}



// w肳ꂽww
// @param buf :: w
// @return pos[int] :: w̕
int AddMove(const char* buf, tree_t *ptree) {
	int from, to;
	int koma, capture;
	int promote;
	unsigned int move = 0;
	int pos = 0;
	char komaName[2], dummy[2], illBuf[10];
	char torankbuf[2], fromrankbuf[2];
	int tofile, torank, fromfile, fromrank;

	// ł
	if (buf[1] == '*') {
		// Ȃ΃R}h́h'''*''''s'"̏ŕł͂
		sscanf(buf, "%1s%1s%1d%1s", komaName, dummy, &tofile, torankbuf);
		koma = MochigomaSFENKomaNameToValue(komaName[0], TURN); // ̎ފmi肩肩j
		torank = torankbuf[0] - 'a'; // rank:i 0~8ŕ\Ƃɂ
		tofile = tofile - 1; // file:؁@Ɠ
		to = tofile * 9 + torank; // c^ŏڌvZ܂

		switch (koma & 0xF) {
		case FU:
			from = drop_pawn;
			koma = pawn;
			break;
		case KY:
			from = drop_lance;
			koma = lance;
			break;
		case KE:
			from = drop_knight;
			koma = knight;
			break;
		case GI:
			from = drop_silver;
			koma = silver;
			break;
		case KI:
			from = drop_gold;
			koma = gold;
			break;
		case KA:
			from = drop_bishop;
			koma = bishop;
			break;
		case HI:
			from = drop_rook;
			koma = rook;
			break;
		default:
			break;
		}
		capture = 0;
		promote = 0;
		pos += 5; // R}h̐擪ʒuύX
	}
	else {
		sscanf(buf, "%1d%1s%1d%1s", &fromfile, fromrankbuf, &tofile, torankbuf);
		fromrank = fromrankbuf[0] - 'a';
		torank = torankbuf[0] - 'a';
		fromfile = fromfile - 1;
		tofile = tofile - 1;
		from = fromfile * 9 + fromrank;
		to = tofile * 9 + torank;
		koma = BOARD[from] & 0x000FU;
		capture = BOARD[to] & 0x000F;
		promote = (buf[4] == '+') ? 1 : 0; // ƃR}h̍Ō+
		pos += promote ? 6 : 5; // +邩ȂœRω
	}

	move = setmove(to, from, promote, koma, capture);

	// ͂ꂽ肪Ȃ
	if (!move_valid(ptree, move, TURN)) {
		if (promote) {
			strncpy(illBuf, buf, 5);
			illBuf[5] = 0;
		}
		else {
			strncpy(illBuf, buf, 4);
			printf("error move %s\n", illBuf);
			illBuf[4] = 0;
		}
		printf("error move %s\n", illBuf);
		printf("error move = %u\n", move);
		printf("cap_piece = %d\n", BOARD[to]);

		return 0;
	}

	// wTURN
	MakeMove(TURN, move, 0);
	TURN = 1 - TURN;
	ptree->tesu++;

	return pos;
}


// ǖʂwi߂ĂAǖʂɂ
void AddAllMoves(const char *buf, int len, tree_t *ptree) {
	char movestr[10000];
	char target[10000];
	int pos, delta;


	strcpy_s(target, _countof(target), " moves ");
	strcpy_s(movestr, _countof(movestr), buf);

	for (int i = 0; i < len; i++) {
		if (movestr[i] == target[0] && movestr[i + 1] == target[1] && movestr[i + 2] == target[2]
			&& movestr[i + 3] == target[3] && movestr[i + 4] == target[4] && movestr[i + 5] == target[5]
			&& movestr[i + 6] == target[6]) {
			pos = i;
			break;
		}
	}
	// strlen("position startpos") = 17, strlen(" moves ") = 7
	// ̌7g7f 8c8dcƂ
	pos = pos + 7;

	// 瑗鏉ǖʂ̎wԂɎw
	while (pos < len) {
		delta = AddMove(buf + pos, ptree);
		if (delta == 0) {
			printf("AddAllMove break\n");
			break;
		}
		pos += delta;
	}
}

void ParseAllTimes(const char* buf, int turn) {

	int blackTime, whiteTime;
	int blackInc, whiteInc;
	string token;
	istringstream is(buf);

	token.clear();
	blackInc = whiteInc = byoyomiTime = 0;

	is >> skipws >> token;

	while (is >> token)
		if (token == "btime")			is >> blackTime;
		else if (token == "wtime")		is >> whiteTime;
		else if (token == "byoyomi")	is >> byoyomiTime;
		else if (token == "binc")		is >> blackInc;
		else if (token == "winc")		is >> whiteInc;
		else if (token == "infinite")	Infinite = true;

		remainTime = (turn == BLACK) ? blackTime : whiteTime;
		incrementTime = (turn == BLACK) ? blackInc : whiteInc;
}

void USI_move(unsigned int move) {

	int fromfile, fromrank;
	int tofile, torank;
	int from, to;
	int promote;
	int piece;

	to = GetMoveTo(move);
	from = GetMoveFrom(move);
	promote = GetMovePromoted(move);
	piece = GetMovePiece(move);
	if (!move) {
		printf("None");
	}
	else {
		if (from < 81) {
			fromfile = from / 9 + 1;
			fromrank = from % 9 + 1;
			printf("%d", fromfile);
			printf("%s", rankSFENNameArray[fromrank]);
		}
		else {
			printf("%s", mochiGomaSFENNameArray[piece]);
			printf("*");
		}
		tofile = to / 9 + 1;
		torank = to % 9 + 1;
		printf("%d", tofile);
		printf("%s", rankSFENNameArray[torank]);
		if (promote) {
			printf("+");
		}
	}
}

// yinfoz񑗐M
void Info(tree_t *ptree, unsigned int *pv, int bestValue) {

	int elapsed, depth, searchedNode;
	elapsed = depth = searchedNode = 1;

	printf("info ");
	printf("time %llu ", elapsed);
	printf("depth %d ", depth);
	printf("seldepth %d ", DEPTH_MAX);
	printf("nodes %llu ", searchedNode);
	printf("score cp %d ", bestValue);
	printf("nps %llu ", searchedNode * 1000 / elapsed);

	if (pv[0] != 0) {
		printf("pv");
		for (int i = 0; i < depth; i++) {
			if (pv[i]) {
				printf(" ");
				USI_move(pv[i]);
			}
			else {
				break;
			}
		}
	}
	printf("\n");
}
