#include "bitboard.h"
#include "usi.h"
#include "shogi.h"

// 񍇖@`FbN
// 0Ԃ΂̎̓G[
int move_valid(tree_t *ptree, unsigned int move, int turn) {
	bitboard_t bb;
	uint64 file_inf;
	int from, to, piece, cap_piece, promote;
	int drop_file;
	int idirec;
	unsigned int hand_inf;

	if (!move) return 0;
	from = (int)GetMoveFrom(move);
	to = (int)GetMoveTo(move);
	piece = (int)GetMovePiece(move);
	cap_piece = (int)GetMoveCapPiece(move);
	promote = (int)GetMovePromoted(move);

	// Ֆʏ̎̈ړ̏ꍇ
	if (from < nsquare) {
		// 肩肩
		if (turn) {
			//邩
			if (BOARD[from] != piece + enemy) {
				return 0;
			}
			// ړ̋̎::Ȃꍇ0
			if (cap_piece) {
				if (BOARD[to] != cap_piece) {
					return 0;
				}
			}
			else {
				if (BOARD[to])
					return 0;
			}
			// J
			if (DiscoverWK(from, to)) {
				return 0;
			}
		}
		else {
			if (BOARD[from] != piece) {
				return 0;
			}
			if (cap_piece) {
				if (BOARD[to] != cap_piece + enemy) {
					return 0;
				}
			}
			else {
				if (BOARD[to]) {
					return 0;
				}
			}
			if (DiscoverBK(from, to)) {
				return 0;
			}
		}

		// ړы
		switch (piece) {
		case 0:
			return 0;
		case lance:
		case bishop:
		case horse:
		case rook:
		case dragon:
			BBor(bb, BB_BOCCUPY, BB_WOCCUPY);
			BBand(bb, bb, obstacle[from][to]);
			if (BBToU(bb)) { //ړԂɋƃG[iщzĂ邱ƂɂȂj
				return 0;
			}
			break;
		}
		return 1;
	}

	// ł
	// łƂɂłɋȂ
	if (BOARD[to]) {
		return 0;
	}
	else {
		hand_inf = turn ? HAND_W : HAND_B;
		switch (DropPiece(from)) {
		case pawn:
			// ł̂ɕĂȂ
			if (!IsHandPawn(hand_inf)) {
				return 0;
			}
			if (turn) {
				drop_file = to / 9;
				if (drop_file == 0) {
					file_inf = BB_WPAWN.p[0];
				}
				else if (drop_file == 8) {
					file_inf = BB_WPAWN.p[2];
				}
				else {
					file_inf = (BB_WPAWN.p[1] >> ((drop_file - 1) * 9)) & 0x01FF;
				}
				// Q̔
				if (file_inf > 0) {
					return 0;
				}
				// łlߔ
				if (BOARD[to + 1] == BOU
					&& is_mate_w_pawn_drop(ptree, to))
				{
					return 0;
				}
			}
			else {
				drop_file = to / 9;
				if (drop_file == 0) {
					file_inf = BB_BPAWN.p[0];
				}
				else if (drop_file == 8) {
					file_inf = BB_BPAWN.p[2];
				}
				else {
					file_inf = (BB_BPAWN.p[1] >> ((drop_file - 1) * 9)) & 0x01FF;
				}
				if (file_inf > 0) {
					return 0;
				}
				if (BOARD[to - 1] == WOU
					&& is_mate_b_pawn_drop(ptree, to))
				{
					return 0;
				}
			}
			return 1;

			// ȉ͎莝ɑΏۋOK
		case lance:
			if (IsHandLance(hand_inf)) {
				return 1;
			}
			break;
		case knight:
			if (IsHandKnight(hand_inf)) {
				return 1;
			}
			break;
		case silver:
			if (IsHandSilver(hand_inf)) {
				return 1;
			}
			break;
		case gold:
			if (IsHandGold(hand_inf)) {
				return 1;
			}
			break;
		case bishop:
			if (IsHandBishop(hand_inf)) {
				return 1;
			}
			break;
		case rook:
			if (IsHandRook(hand_inf)) {
				return 1;
			}
			break;
		default:
			break;
		}
	}

	return 0;
}